// DIVADLL.cpp : Defines the exported functions for the DLL application.
#include "stdafx.h"
#include "DIVADLL.h"
int *genpoint;
int tempgen;

short bitcount (unsigned short x);
short bitcount (unsigned short x)
{
	short b;
	for (b=0;x!=0;b++)
		x&=(x-1);
	return b;
}

DIVADLL_API int divapro (char vbtreeline[], int *genno)
{
	short vbline;
	tempgen=0;
	genpoint=genno;
	vbline=1;
	unsigned short a,b,c,i,j;
	char distrname[20], treename[20],*s, *word;
	/*	char distrname[MAXDISTRNAME], treename[MAXTREENAME],*s, *word;*/ /* JN */
	char temp[MAXLINE+1]; 
	long g;
	float f;
	char m;
	short nlinesread=0;

	/* set up interrupt response */
	signal (SIGINT,OKExit);
	intflag=0;		/*** used to signal when getting keyboard events ***/

	/** set up console if necessary ***/
	/*setup();*/

	/*** initialize ***/
	enex=0;
	echo=0;					/*** default input-output option values ***/
	status=0;
	printrecs=0;
	infile=stdin;
	outfile=stdout;

	absolute=1;				/*** default summary option values ***/
	ambiguous=1;
	classes=1;
	interval=5;
	sumareas=0;
	summax=1<<sumareas;
	amaxhigh=nareashigh=sumaflag=0;
	ancs=terms=disps=ntrees=0;
	integer=1;
	for (j=0;j<6;j++)
		limit[j]=0;

	inblock=OUTOFBLOCK;			/*** default input block mode ***/
	transpose=FALSE;

	tokenset=0;
	taxlabelset=FALSE;		/*** default for tree input ***/

	for (j=1; j<=MAXTAXA; j++) {
		intoa(j,tokenlabel[j]);	/*** default tokenlabels ***/
		intoa(j,taxlabel[j]);	/*** default taxonlabels ***/
	}

	for (i=1;i<=15;i++) {
		charlabel[i][0]='A'+i-1;		/*** default charlabels ***/
		charlabel[i][1]='\0';
	}

	/*** allocate summary variables ***/
	for (j=0; j<=classes+1;j++) {
		freq[j]=(float *) calloc (summax, sizeof (float));
		tempfreq[j]=(short *) calloc (summax, sizeof (short));
	}	
	for (j=0; j<classes; j++)
		for (a=1; a<summax; a++) {
			vicfreq[j][a]=(float *) calloc (1<<(bitcount(a)-1),sizeof(float));
			tempvicfreq[j][a]=(float *) calloc (1<<(bitcount(a)-1),sizeof(float));
		}

		for (i=0;i<16;i++)
			for(j=0;j<16;j++) {
				move[i][j]=(float *) calloc (classes, sizeof (float));
				tempmove[i][j]=(float *) calloc (classes, sizeof (float));
			}

			/*** allocate tree variables **/		
			root= (short *) calloc (2*MAXTAXA,sizeof(short));
			r= (short *) calloc (2*MAXTAXA,sizeof(short));
			l= (short *) calloc (2*MAXTAXA,sizeof(short));
			nodeage= (float*) calloc (2*MAXTAXA,sizeof(float));
			smal= (short *) calloc (2*MAXTAXA,sizeof(short));
			large= (short *) calloc (2*MAXTAXA,sizeof(short));
			nodeclass=(char *) calloc (2*MAXTAXA,sizeof(char));

			/*** allocate distribution array **/
			di= (unsigned short *) calloc (2*MAXTAXA,sizeof(unsigned short));
			ex= (unsigned short *) calloc (2*MAXEXC,sizeof(unsigned short));

			ntax=tree=dist=0;		/*** no taxa, no tree, no distribution set  ***/

new_input:


			switch (vbline) {
			case 1:	
				for (i=0;vbtreeline[i]!=10;i++) {
					temp[i]=vbtreeline[i];
				}
				vbline = vbline+1;
				break;
			case 2:
				if (infile==stdin) {
					printf(">");
					inblock=OUTOFBLOCK;
					signal (SIGINT,OKExit);		/*** signal handling out of execution ***/
				}
				if (infile!=stdin) {			/*** check for interrupt ***/
					nlinesread++;
					if (nlinesread>100) {					/*** suitable interval ***/
						nlinesread=0;
						intflag=0;
					}
				}

				s=fgets (temp,MAXLINE,infile);

				if (s==NULL) {
					if (infile!=stdin) {
						if (feof(infile))
							return 1;//statprint("end of file - control returned to console");
						else
							return 2;//statprint ("file error - control returned to console");

						fclose (infile);
						infile=stdin;
					}
					goto new_input;
				}

				for (word=&temp[0]; *word!='\0';word++)
					if (isgraph(*word))
						break;

				if (*word=='*' || *word=='/') {		/*** echo comments before reading next ***/
					if (infile!=stdin)
						printf ("%s",temp);
					goto new_input;
				}	

				if (*word=='#' || *word=='\0')		/*** ignore NEXUS statements and null lines ***/
					goto new_input;

				break;
			case 3:
				fclose (outfile);
				fclose (infile);
				break;
			}


			/*** copy string from temp to input, remove comments, ignore case ***/
			m=1;
			for (i=j=0; temp[i]!=';' && temp[i]!='\n' && temp[i]!='\0'; i++) {
				if (temp[i]=='[')
					m=0;
				if (m==1) {
					if (isgraph(temp[i]))
						input[j++]=tolower(temp[i]);
					else
						input[j++]=' ';
				}	
				if (temp[i]==']')
					m=1;
			}	

			input[j]='\0';

			while (temp[i]!=';' && j<(MAXLINE-1)) {			/*** get rest of command if long **/
				input[j++]=' ';
				if (infile==stdin)
					printf(">");
				s=fgets (temp,MAXLINE,infile);
				if (s==NULL) {
					eprint("incomplete instruction at end of file - control returned to console");
					infile=stdin;
					goto new_input;
				}
				for (i=0; temp[i]!=';' && temp[i]!='\n' && j<(MAXLINE-1); i++) {
					if (temp[i]=='[')
						m=0;
					if (m==1) {
						if (isgraph(temp[i]))
							input[j++]=tolower(temp[i]);
						else
							input[j++]=' ';
					}	
					if (temp[i]==']')
						m=1;
				}	
			}
			input[j]='\0';

			if (temp[i]!=';' && j>=(MAXLINE-1)) {
				return 3;//eprint("error - too many characters in input");
				goto new_input;
			}

			word=strtok (input," ");
			proc=command(word);
			if (proc==25) /*** equate utree with tree ***/
				proc=9;

			/** block sensitive commands ***/
			if (proc>=18 && proc <=22 && inblock!=DATABLOCK)
				proc=0;
			if (proc==23 && inblock!=TREEBLOCK)
				proc=0;
			if (proc<=14 && proc!=9 && inblock!=DIVABLOCK && inblock!=OUTOFBLOCK)
				proc=0;
			if (proc==9 && inblock!=TREEBLOCK && inblock!=DIVABLOCK && inblock!=OUTOFBLOCK)
				proc=0;
			if (proc>=24 && proc<=25 && inblock!=DIVABLOCK && inblock!=OUTOFBLOCK)
				proc=0;

			/** warn only if appropriate, otherwise ignore ***/
			if (proc==0 && (inblock==DIVABLOCK || inblock==OUTOFBLOCK)) {
				return 4;//eprint ("error - bad command");
				goto new_input;
			}


			/*** correct input ***/


			signal (SIGINT,ignore);			/*** leave signal handling to functions ***/

			switch (proc) {
			case 27:
				word=strtok(NULL," ;");

				temp[0]='\0';
				temp[16]='\0';

				if (word!=NULL && *word=='+') {
					strncpy (temp,word,16);
					strcat (temp," ");
					word=strtok(NULL," ;");
				}
				nexc=exclude (word);
				break;
			case 1:					/***** help ***/

				j=g=0;

				while ((word=strtok(NULL," ;"))!=NULL) {
					i=command(word);
					if (i==0 || (i>14 && i<24)) {
						if (eprint ("warning - illegal help option"))
							break;
					}
					else
						g|=(1<<i);
				}

				if (g==0)
					g=(1<<26)-1;

				if (outfile!=stdout)
					j=help(g,outfile);
				if (j==0 && echo==1)
					j=help(g,stdout);
				if (j==0) {
					if (outfile!=stdout && status==1)
						printf ("help information printed\n");
				}
				else
					statprint ("output of help information interrupted");

				break;

			case 2: 				/**** distribution ****/

				dist=nareas=0;

				word=strtok(NULL," ;");

				temp[0]='\0';
				temp[16]='\0';

				if (word!=NULL && *word=='+') {
					strncpy (temp,word,16);
					strcat (temp," ");
					word=strtok(NULL," ;");
				}

				if (word==NULL) {
					return 5;//eprint ("error - lacking distribution specification");
					goto new_input;
				}

				i=distribution (word);

				if (i==MAXTAXA+2) {
					return 6;//eprint ("error - taxon labels duplicated or erroneous");
					goto new_input;
				}

				if (i==0 || i==MAXTAXA+1) {
					return 7;//eprint ("error - distribution specification erroneous");
					goto new_input;
				}

				if (i!=ntax) { /* Here is the bug! i is not equal to ntax and tree is set to 0. JN*/
					tree=0;
					printf ("\ni is not equal to ntax. set tree to 0\n"); /* JN */
					ntax=i;
				}

				strcpy(distrname,temp);
				statprint (strcat(temp,"distribution read successfully"));
				dist=1;
				if (amax>amaxhigh)
					amaxhigh=amax;
				if (nareas>nareashigh)
					nareashigh=nareas;
				break;

			case 3:				/***  echo ***/	

				echo=status=1;		/*** default ***/
				while ((word=strtok(NULL," ;"))!=NULL) {
					i=option(word);
					if (i==14)
						echo=0;
					else if (i==15)
						echo=1;
					else if (i==21)
						echo=status=0;
					else if (eprint ("warning - illegal echo option"))
						break;
				}

				if (echo)
					statprint ("echo on");
				else if (status)
					statprint ("echo status on");
				else
					statprint ("echo off");
				break;

			case 4:				/***  noecho ***/
				statprint ("echo off");
				echo=status=0;
				break;

			case 5:				/***  optimize  ***/

				if (tree==0) {
					return 8;//eprint("error - no tree specified"); /* Here is the error message. JN */
					goto new_input;
				}

				if (dist==0) {
					return 9;//eprint("error - no distribution specified");
					goto new_input;
				}

				weight=1;				/*** set options to default values ***/
				setbound=MAX;
				keep=1000;
				maxareas=nareas;
				age=1;
				printrecs=0;
				enex=0;

				while ((word=strtok(NULL,"= ;"))!=NULL) {
					i=option(word);

					switch (i) {
					case 23:
						enex=1;
						break;
					case 9:				/*** maxareas ***/

						word=strtok(NULL," ;");

						if (word!=NULL)
							g=atol(word);
						else
							g=0;

						if (g<2 || g>nareas) {
							if (eprint ("warning - bad maxareas argument"))
								goto new_input;
						}
						else
							maxareas=g;
						break;

					case 10:			/*** bound ***/

						word=strtok(NULL," ;");

						if (word!=NULL)
							g=atol(word);
						else
							g=-1;

						if (g<0 || g>MAX) {
							if (eprint ("warning - bad bound argument"))
								goto new_input;
						}
						else
							setbound=g;

						break;

					case 11:			/*** hold ***/
					case 22:			/*** keep ***/

						word=strtok(NULL," ;");

						if (word!=NULL)
							g=atol(word);
						else
							g=0;

						if (g<1 || g>KEEPMAX) {
							if (eprint ("warning - bad hold argument"))
								goto new_input;
						}
						else
							keep=g;

						break;

					case 12:			/*** age ***/

						word=strtok(NULL," ;");

						if (word!=NULL)
							f=atof(word);
						else
							f=0;

						if (f<=0 || f>FLT_MAX) {
							if (eprint ("warning - bad age argument"))
								goto new_input;
						}
						else
							age=f;

						break;

					case 13:			/*** weight ***/

						word=strtok(NULL," ;");

						if (word==NULL)
							f=0;
						else
							f=atof(word);

						if (f>0 && f<=1)
							weight=f;
						else {
							if (eprint ("warning - bad weight argument"))
								goto new_input;		 
						}
						break;

					case 20:		/*** printrecs ***/

						printrecs=1;

						break;

					default:
						if (eprint ("warning - illegal option"))
							goto new_input;
						break;	
					}

				}	

				if (!absolute && age!=1.0)
					agetoclass ();

				intflag=0;

				i=optimize ();

				if (i) {
					if (i==1 && setbound<MAX)
						return 10;//eprint("error - no reconstruction shorter than bound");
					if (i==1 && setbound==MAX)
						return 11;//eprint("error - optimal reconstruction requires too many costs");
					if (i==2 && keep==KEEPMAX)
						return 12;//eprint("error - not possible to fit alternatives within boundaries");
					if (i==2 && keep<KEEPMAX)
						return 13;//eprint("error - overflow of alternatives, try to increase keep");
					if (i==3)
						return 14;//eprint("error - out of memory");
					if (i==4)
						return 15;//eprint("error - out of memory, results not added to counters");
					if (i==5 && infile==stdin) {
						if (sumareas==0)
							return 16;//eprint("optimization aborted");
						else
							return 17;//eprint("optimization aborted - counters unaffected");
					}
					if (i==5 && infile!=stdin) {
						fclose (infile);
						infile=stdin;
					}			
				}
				else
					if (outfile==stdout && infile!=stdin && echo==1) {
						/*JN 03/14/2007 02:37:50 PM CET*/
						/*				if (halt()) {*/ 
						/*					printf("procedure aborted - control returned to console\n");*/
						/*					fclose (infile);*/
						/*					infile=stdin;*/
						/*				}*/
					}

					intflag=0;

					break;

			case 6:				/*** output ***/

				word=strtok(NULL," ;");

				if (word==NULL) {
					return 18;//eprint ("error - lacking filename");
					goto new_input;
				}	

				if (outfile!=stdout) {
					fclose (outfile);
					outfile=stdout;
					statprint("previous output file closed");
				}

				if (strcmp(word,"--")!=0) {
					outfile=fopen(word,"r");
					if (outfile!=NULL)	{
						fclose (infile);
						fclose (outfile);
						return 100;//eprint ("error - this file already exists");
						break;
					}
					outfile=fopen(word,"w");
				}

				if (outfile==NULL) {
					outfile=stdout;
					return 21;//eprint ("error - could not open file");
				}		
				else
					if (strcmp(word,"--")!=0)
						statprint (strcat(word," opened as output file"));
				break;

			case 7:				/*** proc ***/

				word=strtok(NULL," ;");

				if (word==NULL) {
					return 22;//eprint ("error - lacking filename");
					goto new_input;
				}

				if (strcmp(word,"--")==0 && infile!=stdin) {
					infile=stdin;
					statprint ("control returned to console");
					break;
				}

				if (infile!=stdin)
					fclose (infile);

				infile=fopen(word,"r");

				if (infile==NULL) {
					infile=stdin;
					return 23;//eprint ("error - could not open file");
				}
				else
					statprint (strcat(word," opened as proc file"));

				break;

			case 8:				/*** return ***/

				vbline = vbline+1;
				goto new_input;

				break;

			case 9:				/*** tree ***/

				if (inblock==TREEBLOCK && dimensionsset==FALSE) {
					return 24;//eprint ("error - lacking dimensions statement");
					break;
				}

				word=strtok(NULL," =;");

				if (*word=='*')
					word=strtok (NULL," =;");

				temp[0]=temp[16]='\0'; /* Check this '16'. JN */

				if (word!=NULL && *word!='(') {
					strncpy (temp,word,16); /* Check this '16'. JN */
					strcat (temp, " ");
					word=strtok(NULL," =;");
				}

				if (word==NULL) {
					return 25;//eprint ("error - lacking tree specification");
					goto new_input;
				}

				for (;(s=strtok(NULL," ;"))!=NULL;strcat(word,s))	/*** skip spaces in spec **/
					;
				b=ntax;

				ntax=stringtotree (word);

				if (ntax!=b)			/*** new tree - no distribution ***/
					dist=0;

				if (ntax==0) {
					return 26;//eprint ("error - bad tree specification");
					goto new_input;
				}

				age=1.0;
				agetoclass();

				strcpy (treename,temp);
				statprint (strcat(temp,"tree read successfully"));

				tree=1;					/**** tree specified ***/

				break;

			case 10:				/*** quit ***/

				exit (0);
				break;

			case 11:				/*** reset ***/

				for (j=0; j<=classes;j++) {			/*** free summary variables ***/
					free (freq[j]);
					free (tempfreq[j]);
				}
				for (j=0; j<classes; j++)
					for (a=1; a<summax; a++) {
						free (vicfreq[j][a]);
						free (tempvicfreq[j][a]);
					}
					for (i=0;i<16;i++)
						for(j=0;j<16;j++) {
							free (move[i][j]);
							free (tempmove[i][j]);
						}

						absolute=1;				/*** set options to default values ***/
						ambiguous=1;
						classes=1;
						interval=5;
						sumareas=0;
						integer=1;
						b=0;			/*** no interval set ***/

						terms=ancs=disps=ntrees=0;
						amaxhigh=nareashigh=sumaflag=0;

						for (j=0;j<6;j++)
							limit[j]=0;

						while ((word=strtok(NULL,"= ;"))!=NULL) {

							switch (option(word)) {

							case 2:				/*** ambiguous ***/

								ambiguous=1;
								break;

							case 3:				/*** unambiguous ***/

								ambiguous=0;
								break;

							case 4:				/*** relative ***/

								absolute=0;
								break;

							case 5:				/*** absolute ***/

								absolute=1;
								break;

							case 6:				/*** classes ***/

								word=strtok(NULL," ;");

								if (word!=NULL)
									g=atol(word);
								else
									g=0;

								if (g<1 || g>5) {
									if (eprint ("warning - bad classes argument"))
										goto reallocate;
								}
								else
									classes=g;
								break;

							case 7:				/*** interval ***/

								word=strtok(NULL," ;");

								if (word!=NULL)
									f=atof(word);
								else
									f=0;

								if (f<=0 || f>FLT_MAX) {
									if (eprint ("warning - bad interval argument"))
										goto reallocate;
								}
								else {
									interval=f;
									b=1;
								}		
								break;

							case 8:				/*** sumareas ***/

								word=strtok(NULL," ;");

								if (word!=NULL)
									g=atol(word);
								else
									g=0;

								if (g<0 || g>8) {
									if (eprint ("warning - bad sumareas argument"))
										goto reallocate;
								}
								else
									sumareas=g;

								break;
							case 19:			/*** bounds ***/

								word=strtok(NULL," ;");

								if (word!=NULL)
									g=atol(word);
								else
									g=0;

								if (g<1 || g>4) {
									if (eprint ("warning - bad bounds argument"))
										goto reallocate;
								}
								else
									a=g;

								for (j=1; j<=a; j++) {
									word=strtok(NULL," ;");

									if (word!=NULL)
										f=atof(word);
									else
										f=0;

									if (f<=limit[j-1] || f>FLT_MAX) {
										if (eprint ("warning - bad bounds argument"))
											goto reallocate;
										break;
									}

									else
										limit[j]=f;

								}

								for (j=a+1;j<6;j++)
									limit[j]=0;

								break;

							default: 			/*** illegal option ***/

								if (eprint ("warning - illegal option"))
									goto reallocate;

								break;

							}	

						}

						if (!absolute) {				/*** set interval & integer ***/
							integer=0;
							if (b==0)
								interval=0.5;
						}

						for (j=1;j<classes;j++) {				/*** fix bounds && check integer ***/
							if (limit[j]<limit[j-1]+1)
								limit[j]=limit[j-1]+interval;
							if (limit[j]-(int)limit[j]!=0)
								integer=0;
						}

reallocate:
						summax=1<<sumareas;		/*** reallocate summary variables ***/

						for (j=0; j<=classes;j++) {	
							freq[j]=(float *) calloc (summax, sizeof (float));
							tempfreq[j]=(short *) calloc (summax, sizeof (short));
						}
						for (j=0; j<classes; j++)
							for (a=1; a<summax; a++) {
								vicfreq[j][a]=(float *) calloc (1<<(bitcount(a)-1),sizeof(float));
								tempvicfreq[j][a]=(float *) calloc (1<<(bitcount(a)-1),sizeof(float));
							}
							for (i=0;i<16;i++)
								for(j=0;j<16;j++) {
									move[i][j]=(float *) calloc (classes, sizeof (float));
									tempmove[i][j]=(float *) calloc (classes, sizeof (float));
								}

								statprint ("counters for summary statistics reset");
								break;

			case 12:				/**** sum ****/

				a=bitcount(sumaflag&(summax-1));

				if (a<2) {
					if (a==0)
						return 27;//eprint ("error - no reconstructions summarized");
					else
						return 28;//eprint ("error - only one area in reconstruction(s) summarized");
					goto new_input;
				}

				if (echo!=1 && outfile==stdout) {
					return 29;//eprint ("error - no output stream selected; set echo on or specify output file");
					break;
				}

				while ((word=strtok(NULL,"= ;"))!=NULL) {
					switch(option(word)){

					case 1:							/*** areas ***/	

						word=strtok(NULL," ;");
						if (word!=NULL)
							g=atol(word);
						else
							g=0;

						if (g<2 || g>sumareas) {
							if(eprint ("warning - bad areas argument"))
								goto new_input;
						}
						else
							a=g;
						break;

					default:						/*** illegal option ***/

						if (eprint ("warning - illegal option"))
							goto new_input;
						break;	

					}
				}

				intflag=0;

				if (outfile!=stdout)
					printsum (outfile,a);

				if (echo==1 && intflag==0)
					printsum(stdout,a);

				if (intflag)
					if (infile==stdin)
						statprint ("output of summary statistics aborted");
					else {
						fclose (infile);
						infile=stdin;
					}
				else {
					if (outfile!=stdout && status)
						printf ("summary statistics calculated");
					/*			if (outfile==stdout && infile!=stdin && echo==1)*/
					/*				if (halt()) {*/
					/*					printf("procedure aborted - control returned to console\n");*/
					/*					fclose (infile);*/
					/*					infile=stdin;*/
					/*				}*/
				}

				intflag=0;

				break;

			case 13:								/**** rarefy ***/

				word=strtok(NULL," ;");

				if (word==NULL) {
					return 30;//eprint ("error - lacking input filename");
					goto new_input;
				}

				rarein=fopen(word,"r");

				if (rarein==NULL) {
					return 31;//eprint ("error - could not open file");
					goto new_input;
				}

				b=0;				/*** set defaults ***/
				srand(1);
				nrep=1;
				temp[0]='\0';

				while ((word=strtok(NULL,"= ;"))!=NULL) {
					switch(option(word)){

					case 1:							/*** areas ***/	

						word=strtok(NULL," ;");
						if (word!=NULL)
							i=disttono(word);
						else
							i=0;

						if (bitcount(i)<2) {
							if(eprint ("warning - bad areas argument")) {
								fclose (rarein);
								goto new_input;
							}
						}
						else
							b=i;
						break;

					case 16:						/*** output ***/

						word=strtok(NULL," ;");

						strcpy(temp,word);

						break;

					case 17:						/*** seed ***/

						word=strtok(NULL," ;");
						if (word!=NULL)
							g=atol(word);
						else
							g=0;

						if (g==0) {
							if(eprint ("warning - bad seed argument")) {
								fclose (rarein);
								goto new_input;
							}
						}
						else
							srand(g);

						break;

					case 18:						/*** nrep ***/

						word=strtok(NULL," ;");
						if (word!=NULL)
							g=atol(word);
						else
							g=0;

						if (g<=0 || g>SHRT_MAX) {
							if(eprint ("warning - bad nrep argument")) {
								fclose (rarein);
								goto new_input;
							}
						}
						else
							nrep=g;

						break;


					default:						/*** illegal option ***/

						if(eprint ("warning - illegal option")) {
							fclose (rarein);
							goto new_input;
						}
						break;	
					}

				}

				proc=0; 			/*** for correct eprint handling ***/

				if (b==0) {
					fclose (rarein);
					return 32;//eprint ("error - no specification of areas");
					goto new_input;
				}

				if (temp[0]=='\0') {
					fclose (rarein);
					return 33;//eprint ("error - lacking output specification");
					goto new_input;
				}

				rareout=fopen(temp,"r");
				if (rareout!=NULL)	{
					fclose (rareout);
					fclose (rarein);
					return 34;//eprint ("error - this file already exists");
					goto new_input;
				}

				rareout=fopen(temp,"w");

				if (rareout==NULL) {
					fclose (rarein);
					return 35;//eprint ("error - could not open outfile");
					goto new_input;
				}

				intflag=0;
				i=rarefy(b);

				if (i==0)
					statprint ("rarefaction completed successfully");

				if (i==2)
					return 36;//eprint ("error - no occurrences in one of the specified areas");

				if (i==3)
					return 37;//eprint ("error - no relevant content in file to be rarefied");

				if (intflag) {
					statprint ("rarefaction aborted");
					intflag=0;
				}

				fclose (rarein);
				fclose (rareout);

				intflag=0;

				break;

			case 14:			/*** nodeage ***/

				if (tree==0) {
					return 38;//eprint ("error - no tree specified");
					goto new_input;
				}

				f=0;

				for (j=ntax+1;j<2*ntax;j++) {

					word=strtok(NULL," ;");

					f=atof(word);

					if (f<nodeage[l[j]] || f<nodeage[r[j]] ||
						f>FLT_MAX || f==0)
						break;

					nodeage[j]=f;
				}

				if (j!=2*ntax || strtok(NULL," ;")!=NULL) {
					return 39;//eprint ("error - nodeage specification erroneous");
					goto new_input;
				}

				agetoclass();

				statprint ("nodeages set successfully");
				break;		

			case 15:		/*** BEGIN ***/

				word = strtok(NULL," ;");

				if (strcmp(word,"diva")==0)
					inblock=DIVABLOCK;
				else if (strcmp(word,"data")==0) {
					inblock=DATABLOCK;
					dimensionsset=FALSE;
					transpose=FALSE;
					taxlabelset=FALSE;
				}
				else if (strcmp(word,"trees")==0) {
					inblock=TREEBLOCK;
					if (dimensionsset==FALSE) {
						return 40;//eprint ("error - tree block encountered without preceding dimensions statement");
						goto new_input;
					}
					tokenset=0;
				}
				else
					inblock=FOREIGNBLOCK;


				break;

			case 16:		/*** ENDBLOCK ***/

				if (inblock==TREEBLOCK) {
					for (i=1;i<=ntax; i++)
						intoa(i,tokenlabel[i]);
					tokenset=0;
				}
				inblock=OUTOFBLOCK;

				break;

			case 17:		/*** END ***/

				if (inblock==TREEBLOCK) {
					for (i=1;i<=ntax; i++)
						intoa(i,tokenlabel[i]);
					tokenset=0;
				}
				inblock=OUTOFBLOCK;

				break;

			case 18:		/*** DIMENSIONS ***/

				dist=0;
				a=b=0;

				/*** get ntax and nchar ***/

				while ((word=strtok(NULL," =;"))!=NULL) {
					if (strcmp(word,"ntax")==0)
						c=1;
					else if (strcmp(word,"nchar")==0)
						c=2;
					else {
						eprint ("error - incorrect dimensions statement");
						goto new_input;
					}

					if ((word = strtok (NULL," =;"))==NULL) {
						eprint ("error - incorrect dimensions statement");
						goto new_input;
					}

					g=atol(word);	

					if (c==1) {					/*** set NTAX ***/
						if (g>MAXTAXA) {
							eprint("error - too many taxa");
							goto new_input;
						}
						if (g<2) {
							eprint("error - too few taxa");
							goto new_input;
						}
						a=g;
					}	
					else {						/*** set NCHAR ***/

						if (g<1) {
							eprint("error - too few areas");
							goto new_input;
						}
						if (g>15) {
							eprint ("error - too many areas");
							goto new_input;
						}
						b=g;
					}
				}

				/*** ntax and nchar OK? ***/

				if (a==0 || b==0) {
					eprint ("error - incorrect dimensions statement");
					goto new_input;
				}

				if (a!=ntax) {
					ntax=a;
					tree=0;
				}

				nareas=b;

				dimensionsset=TRUE;

				break;

			case 19:			/***MATRIX ***/

				if (dimensionsset==FALSE) {
					eprint ("error - no dimensions set");
					break;
				}

				word=strtok(NULL,";");

				if (matrix(word)) {
					eprint ("error - incorrect matrix specification");
					taxlabelset=FALSE;
					for (i=0;i<15;i++) {
						charlabel[i][0]='A'+i;		/*** reset charlabels ***/
						charlabel[i][1]='\0';
					}
					for (i=1; i<=ntax; i++)
						intoa(i,taxlabel[i]);		/*** reset taxlabels ***/
					goto new_input;
				}
				else {
					statprint ("distribution matrix read successfully");
					dist=1;
					if (amax>amaxhigh)
						amaxhigh=amax;
					if (nareas>nareashigh)
						nareashigh=nareas;
					if (transpose==FALSE)
						taxlabelset=TRUE;
				}
				break;

			case 20:			/*** FORMAT ***/

				while ((word=strtok (NULL, " =;"))!=NULL) {
					if (strcmp(word,"transpose")==0)
						transpose=TRUE;
				}
				break;

			case 21:			/*** CHARLABELS ***/

				if (dimensionsset==FALSE) {
					eprint ("error - no dimensions set");
					goto new_input;
				}

				word=strtok(NULL,";");

				a=charlabels(word);

				if (a>nareas || a<=0) {
					eprint ("error - incorrect charlabels statement");
					for (i=0;i<15;i++) {
						charlabel[i][0]='A'+i;		/*** reset charlabels ***/
						charlabel[i][1]='\0';
					}
					goto new_input;
				}

				break;

			case 22:			/*** TAXLABELS ***/

				if (dimensionsset==FALSE) {
					eprint ("error - no dimensions set");
					goto new_input;
				}

				word=strtok(NULL,";");

				if (taxlabels(word)>ntax) {
					eprint ("error - too many taxlabels");
					for (i=1; i<=ntax; i++)
						intoa(i,taxlabel[i]);		/*** reset taxlabels ***/
					goto new_input;
				}

				taxlabelset=TRUE;

				break;

			case 23:			/*** TRANSLATE ***/

				if (dimensionsset==FALSE)
					break;

				tokenset=0;

				word=strtok(NULL,";");

				if (translate(word)==MAXTAXA+1) {
					eprint ("error - duplicated or incorrect number of tokens");
					for (i=1;i<=MAXTAXA; i++)
						intoa(i,tokenlabel[i]); 	/*** set tokenlabels to default ***/
				}
				else
					tokenset=1;
				break;

			case 24:			/*** showareas ***/

				if (outfile!=stdout)
					showareas (outfile);

				if (echo==1)
					showareas (stdout);
				break;

			case 25:			/*** showtaxa ***/

				if (taxlabelset==FALSE) {
					eprint ("error - no taxlabels set");
					break;
				}

				if (outfile!=stdout)
					showtaxa (outfile);

				if (echo==1)
					showtaxa (stdout);
				break;

			default:
				break;

			}

			goto new_input;

			return 0;

}

char rarefy (unsigned short b)
{
	extern short nrep;
	extern FILE *rarein,*rareout;
	extern char tree,dist,nareas;
	extern short ntax;

	unsigned short i,j,a,c,d,n,neu,ditemp[2*MAXTAXA],area[16],max;
	unsigned long threshold[16];
	char *s,*word, optimizecopy[MAXLINE],*t;
	char temp[MAXLINE],nodeagecopy[MAXLINE],nodeageset; 
	double f;
	long lg;
	float occ[16],rarest,g[2*MAXTAXA];

	/** initialize **/
	max=0;
	for (i=1; i<=b; i<<=1)
		if (b&i)
			area[max++]=i;

	/*** calculate frequency ***/

	a=0;		/*** no relevant command encountered ***/

	dist=tree=ntax=0;		/*** reset variables ***/
	for (c=0;c<max;c++)
		occ[c]=0;

	/**** read until EOF, return, quit or proc  encountered ***/
	while ((i=instring (rarein,input))!=100 && i!=8 && i!=10 && i!=7) {

		if (intflag)
			return 1;

		if (a && i==11)
			break;			/*** break if reset encountered after an optimize ***/

		word=strtok(input," ;");		/** get command **/

		switch (i) {

		case 2:			/**** distribution ***/

			j=dist=0;

			if (tree==0)
				if (eprint ("warning - distribution command encountered but no tree specified"))
					return 1;

			if (tree!=0) {
				word=strtok(NULL," ;");

				if (*word=='+')
					word=strtok(NULL," ;");
				if (word!=NULL)
					j=distribution (word);
			}

			if (j>MAXTAXA) {
				if (eprint("warning - erroneous distribution specification"))
					return 1;
			}
			else {
				if (j!=ntax) {
					ntax=j;
					tree=0;
				}
				dist=1;
			}

			break;

		case 5:		/*** optimize ***/

			a=1;

			if (tree==0) {
				if (eprint("warning - optimize command encountered but no tree specified"))
					return 1;
				else
					break;
			}
			if (dist==0) {
				if (eprint("warning - optimize command encountered but no distribution specified"))
					return 1;
				else
					break;
			}

			weight=1;
			while ((word=strtok(NULL,"= ;"))!=NULL) {
				switch (option(word)) {

				case 9:				/*** maxareas ***/

					word=strtok(NULL," ;");

					if (word!=NULL)
						lg=atol(word);
					else
						lg=0;

					if (lg<2 || lg>nareas)
						if (eprint ("warning - bad maxareas argument"))
							return 1;
					break;

				case 10:			/*** bound ***/

					word=strtok(NULL," ;");

					if (word!=NULL)
						lg=atol(word);
					else
						lg=MAX+1;

					if (lg<0 || lg>MAX)
						if (eprint ("warning - bad bound argument"))
							return 1;
					break;

				case 11:			/*** hold ***/

					word=strtok(NULL," ;");

					if (word!=NULL)
						lg=atol(word);
					else
						lg=0;

					if (lg<1 || lg>KEEPMAX)
						if (eprint ("warning - bad hold argument"))
							return 1;
					break;

				case 12:			/*** age ***/

					word=strtok(NULL," ;");

					if (word!=NULL)
						f=atof(word);
					else
						f=0;

					if (f<=0 || f>FLT_MAX)
						if (eprint ("warning - bad age argument"))
							return 1;
					break;

				case 13:			/*** weight ***/

					word=strtok(NULL," ;");

					if (word==NULL)
						f=0;
					else
						f=atof(word);

					if (f>0 && f<=1)
						weight=f;
					else
						if (eprint ("warning - bad weight argument"))
							return 1;
					break;

				case 20:		/*** printrecs ***/

					break;

				default:
					if (eprint ("warning - illegal optimize option"))
						return 1;
					break;	
				}
			}

			/*** summarize frequency of areas ***/

			for (j=1;j<=ntax;j++) {
				for(c=0;c<max;c++) {
					if(area[c]&di[j])
						occ[c]+=weight;
				}
			}
			break;

		case 9:				/*** tree ***/

			d=ntax;
			tree=ntax=0;
			nodeageset=0;

			word=strtok(NULL," ;");

			if (*word!='(')
				word=strtok(NULL," ;");

			if (word!=NULL) {
				/*** skip spaces in spec **/
				for (;(s=strtok(NULL," ;"))!=NULL;strcat(word,s))
					;

				ntax=stringtotree (word);

			}

			if (ntax==0) {
				if (eprint("warning - erroneous tree specification"))
					return 1;
			}
			else
				tree=1;

			if (ntax!=d)
				dist=0;

			break;

		case 14:			/*** nodeage ***/
			if (tree==0 && eprint ("warning - no tree specified"))
				return 1;

			for (j=1; j<=ntax; j++)
				g[j]=0;

			for (j=ntax+1;j<2*ntax;j++) {

				word=strtok(NULL," ;");

				f=atof(word);

				if (f<g[l[j]] || f<g[r[j]] ||
					f>FLT_MAX || f==0)
					break;
			}

			g[j]=f;

			if (j!=2*ntax || strtok(NULL," ;")!=NULL)
				if (eprint ("warning - erroneous nodeage specification"))
					return 1;

			nodeageset=1;

			break;		

		default:					/*** do nothing if not necessary ***/	
			break;
		}
	}

	if (a==0)			/*** nothing relevant in rarein ***/
		return 3;

	rarest=occ[0];

	for (c=1;c<max;c++) {
		if (occ[c]<rarest)
			rarest=occ[c];
	}
	if (rarest==0)
		return 2;

	for (c=0; c<max; c++)
		threshold[c]=RAND_MAX*rarest/occ[c];

	for (n=0; n<nrep; n++) {
		rewind(rarein);
		dist=tree=nodeageset=0;
		a=0; 	/*** no optimize command issued ***/

		while ((i=instring (rarein,input))!=100 && i!=8 && i!=10 && i!=7) {
			if (intflag)
				return 1;

			if (a && i==11)
				break;			/*** break if reset after an optimize **/

			word=strtok(input," ;");		/** get command **/

			switch (i) {

			case 2:					/*** distribution ***/

				d=dist=nareas=0;

				if (tree!=0) {
					word=strtok(NULL," ;");

					if (*word=='+')
						word=strtok(NULL," ;");
					if (word!=NULL)
						d=distribution (word);

					if (d==ntax)
						dist=1;
				}
				break;

			case 9:					/*** tree ***/

				d=ntax;
				tree=ntax=nodeageset=0;

				word=strtok(NULL," ;");

				if (*word!='(')
					word=strtok(NULL," ;");

				if (word!=NULL) {
					/*** skip spaces in spec **/
					while ((s=strtok(NULL," ;"))!=NULL)
						strcat(word,s);

					ntax=stringtotree (word);

				}

				if (ntax!=0)
					tree=1;
				if (ntax!=d)
					dist=0;

				break;

			case 14:				/*** nodeage ***/

				strcpy (nodeagecopy,"nodeage ");
				strcat(nodeagecopy,strtok(NULL,";"));
				nodeageset=1;
				break;

			case 5:					/*** optimize ***/

				a=1;

				if (tree==0 || dist==0)
					break;

				strcpy (optimizecopy,"optimize");
				if ((t=strtok(NULL,";"))!=NULL)
					strcat(strcat(optimizecopy," "),t);

				/*** exterminate ***/
				for (j=1;j<=ntax;j++)	/** copy in case dist used again **/
					ditemp[j]=di[j];

				for (j=1;j<=ntax;j++)
					for(c=0;c<max;c++)
						if ((area[c]&ditemp[j]) && rand()>threshold[c])
							ditemp[j]^=area[c];

				i=0;
				for (j=1;j<=ntax;j++)
					if (ditemp[j]!=0)
						i++;

				if (i<2)
					break;			/*** ignore if less than two taxa left **/

				for (j=ntax+1; j<2*ntax; j++)		/*** set extinct ancestors to 0 ***/
					ditemp[j]=(ditemp[l[j]]|ditemp[r[j]]);

				/*** write new tree ***/
				fprintf(rareout,"tree ");

				i=0;		/*** largest terminal accounted for**/
				j=2*ntax-1;		/*** the node where we are **/
				neu=0;		/*** no. taxa written to new tree **/

				while (j<2*ntax) {
					while (j>ntax) {		/*** pass up tree **/
						if (ditemp[r[j]]!=0 && ditemp[l[j]]!=0)
							fprintf (rareout,"(");
						if (smal[j]>i && ditemp[l[j]]!=0)
							j=l[j];
						else
							j=r[j];
					}
					i=j;
					intoa(++neu,temp);
					fprintf(rareout,"%s",temp);
					j=root[j];
					while (large[j]==i || ditemp[r[j]]==0) {	/** pass down **/
						if (ditemp[r[j]]!=0 && ditemp[l[j]]!=0)
							fprintf (rareout,")");
						if (j<2*ntax-1)
							j=root[j];
						else {
							j++;		/** passed out of tree=finished **/
							break;
						}
					}
					if (j<2*ntax) {
						fprintf (rareout,",");
						j=r[j];
					}
				}

				fprintf (rareout,";\n");

				/*** write distribution ***/
				fprintf (rareout,"distribution");
				for (j=1; j<=ntax; j++) {
					if (ditemp[j]!=0) {
						notodist(ditemp[j],temp);
						fprintf (rareout," %s",temp);
					}
				}
				fprintf (rareout,";\n");

				if (nodeageset)							/** write nodeage if set **/
					fprintf (rareout,"%s;\n",nodeagecopy);

				fprintf (rareout,"%s;\n",optimizecopy);	/** write optimize **/
				break;

			default:
				break;						/** do not write other lines **/

			}								
		}
	}		


	fprintf (rareout,"return;\n");

	ntax=tree=dist=0;

	return 0;

}	

/*** instring: input string from infile, return command (100 if EOF), string in s ***/
char instring (FILE *fp, char *s)
{
	char temp[MAXLINE+1],t[35],*word;
	short i,j,index;


	/*JN 03/14/2007 02:38:42 PM CET*/
	/*	if (interrupt() && OKStop())*/
	/*		return 101;*/

	if (fgets(temp,MAXLINE,fp)==NULL)
		return 100;

	for (i=0; temp[i]!=';' && temp[i]!='\n'; i++)
		s[i]=tolower(temp[i]);

	s[i]='\0';

	t[30]='\0';
	strncpy (t,s,30);

	word=strtok(t," ;");

	j=0;

	if (word==NULL || (j=command(word))==0)
		return 0;

	index=i;

	/*** get rest of command if long **/

	while (temp[i]!=';' && index<MAXLINE) {

		input[index++]=' ';

		if (fgets(temp,MAXLINE,fp)==NULL)
			return 100;

		for (i=0; temp[i]!=';' && temp[i]!='\n' && index<MAXLINE;i++) {
			s[index]=tolower(temp[i]);
			index++;
		}
	}

	s[index]='\0';

	if (temp[i]!=';' || index==MAXLINE)
		return 0;

	return j;
}

short bits (unsigned short x);

/*** bits: count bits in an unsigned short, inline function to improve speed ***/
short bits (unsigned short x)
{

	short b;

	for (b=0;x!=0;b++)

		x&=(x-1);

	return b;

}

/*** stringtotree: convert treespec s to tree, return 0 if failure else ntax in tree ***/
/*char stringtotree (char *s)*/ /* JN. Changed the return type. 12/11/2007 09:39:15 PM CET.*/
unsigned short stringtotree (char *s)
{
	extern short *root,*smal,*large,*l,*r;
	extern float *nodeage;
	extern short ntax;
	extern char tokenset, inblock, taxlabelset;
	extern char taxlabel[][17],tokenlabel[][17]; /* Check '17'. JN */

	short b3,b2,b1,ia,ib,c;

	char label[MAXTAXA+1][17], match[MAXTAXA+1]; /* Check '17'. JN */
	char copy[MAXLINE],*t,u[5],*v; /* Check '5'. JN */
	char istoken=0, istaxlabel=0;

	/*** set labels, count number taxa ***/

	strcpy (copy,s);	

	t=strtok (copy,"(),");

	for (ia=1; t!=NULL;ia++) {
		strncpy(label[ia],t,16); /* Check '16'. JN */
		label[ia][16]='\0'; /* Check '16'. JN */
		t=strtok(NULL,"(),");
	}

	/*** if new set of taxa, reset taxonlabels ***/
	if ((ia-1)!=ntax) {
		if (inblock==TREEBLOCK)
			return 0;
		taxlabelset=FALSE;
		for (ib=1; ib<=MAXTAXA; ib++)
			intoa (ib, taxlabel[ib]);
	}		

	ntax=ia-1;

	if (ntax==0)
		return 0;

	/*** check if labels match tokenlabels; default is taxonnumbers ***/
	istoken=1;
	for (ia=1; ia<=ntax; ia++)
		match[ia]=0;
	for (ia=1; ia<=ntax; ia++) {
		for (ib=1; ib<=ntax; ib++)
			if (strcmp(label[ia],tokenlabel[ib])==0)
				break;
		if (ib>ntax || match[ib]==1) {
			istoken=0;
			break;
		}
		match[ib]=1;
	}
	if (!istoken && tokenset)
		return 0;

	/*** check if labels match specified taxlabels if not tokenlabels ***/
	if (!istoken && taxlabelset==TRUE) {
		istaxlabel=1;
		for (ia=1; ia<=ntax; ia++)
			match[ia]=0;
		for (ia=1; ia<=ntax; ia++) {
			for (ib=1; ib<=ntax; ib++)
				if (strcmp(label[ia],taxlabel[ib])==0)
					break;
			if (ib>ntax || match[ib]==1) {
				istaxlabel=0;
				break;
			}
			match[ib]=1;
		}
	}

	/*** set taxlabels from tree, reset remaining taxlabels ***/
	if (!istoken && !istaxlabel) {
		if (inblock==TREEBLOCK)
			return 0;
		istaxlabel=1;
		for (ia=1; ia<=ntax; ia++) {
			strncpy (taxlabel[ia],label[ia],16);	/** set labels **/
			taxlabel[ia][16]='\0';		
		}
		taxlabelset=TRUE;
	}


	/*** convert labels to taxon numbers in copy if taxlabels or preset tokens ***/
	if (tokenset || istaxlabel) {
		for (ia=0; ia<=MAXLINE; ia++)		/** empty string needed **/
			copy[ia]='\0';

		ia=1;			/*** label number being replaced ***/
		ib=0;			/*** position in copy **/
		b1=0;			/*** not taxlabel part **/

		for (t=s; *t!='\0'; t++) {
			if (*t=='(' || *t==')' || *t==',') {
				if (b1==1) {
					for (c=1; c<=ntax; c++) {			/*** find number to replace with **/
						if (istoken && strcmp(tokenlabel[c],label[ia])==0)
							break;
						if (istaxlabel && strcmp(taxlabel[c],label[ia])==0)
							break;
					}
					intoa(c,u);
					strcat(copy,u);
					ib=ib+strlen(u);
					ia++;			/*** next label up ***/
					b1=0;			/*** out of taxlabel part **/
				}
				copy[ib++]=*t;
			}
			else
				b1=1;		/*** in taxlabel part **/
		}

		strcpy (s,copy);			/*** copy result to s ***/
	}

	for (ia=1;ia<=ntax;ia++)		/*** reset nodeages ***/
		nodeage[ia]=0;

	/*** convert string to tree ***/

	strcpy (copy,s);		/*** work with copy and not with s ***/

	for (b3=ntax+1; b3<2*ntax; b3++) {

		for (ia=1; (c=copy[ia])!=')'; ia++)
			if (c=='\0')
				return 0;			/*** can't find right parenthesis **/

		for (ib=ia-1; (c=copy[ib])!='('; ib--)
			if (ib==0)
				return 0;			/*** can't find left parenthesis **/

		s=&copy[ib+1];				/*** pointer to first position **/

		for (t=s; isdigit (*t);t++)
			u[t-s]=*t;
		u[t-s]='\0';

		if (u[0]=='\0')
			return 0;				/*** can't find first number ***/

		b1=atoi(u);

		if (*t!=',')
			return 0;				/*** bad format ***/

		for (v=++t; isdigit (*t);t++)
			u[t-v]=*t;
		u[t-v]='\0';

		if (u[0]=='\0')
			return 0;				/*** can't find second number ***/

		b2=atoi(u);

		if (*t!=')')
			return 0;				/*** bad format ***/		

		/*** pair b1 and b2 in b3 ***/	
		root[b1]=root[b2]=b3;	
		l[b3]=b1;
		r[b3]=b2;

		/*** set min. time for node***/
		nodeage[b3]=((nodeage[b1]>nodeage[b2]) ? nodeage[b1] : nodeage[b2])+1; 


		if (b1<=ntax)				/**** set range of terminals subtended by node **/
			smal[b3]=b1;
		else
			smal[b3]=smal[b1];
		if (b2<=ntax)
			large[b3]=b2;
		else
			large[b3]=large[b2];

		/*** update copy, s and t points to locations in copy***/

		*(--s)='\0';					/*** truncate s ***/

		intoa(b3,u);

		strcat(copy,u);
		strcat(copy,++t);				

	}

	if (strlen(copy)!=strlen(u))
		return 0;

	return ntax;
}

/*** distribution: check string, fill di[i], return no. filled, MAXTAXA+1 if string ***/
/*** too long, MAXTAXA+2 if duplicated or erroneous taxonlabels ***/


short exclude (char *s)
{
	extern unsigned short *ex;
	unsigned short j;
	short k=0;
	/*** reset ex[] ***/
	for (j=0; j<=MAXEXC; j++)
		ex[j]=0;
	for (j=0; j<=MAXEXC; j++) {
		if (s==NULL)
			break;
		/*** exclude spec **/
		ex[k]=disttono(s);		/*** set di using s **/
		if (ex[k]==0)
			return k-1;			/*** erroneous exclude ***/	
		s=strtok(NULL," ;");	
		k++;
	}
	return k-1;
}
short distribution (char *s)

{

	extern unsigned short *di,aflag;
	extern long amax;
	extern char nareas;

	short n;	
	unsigned short j,x;
	long k;

	/*** reset di[] ***/
	for (j=1; j<=MAXTAXA; j++)
		di[j]=0;

	for (j=1; j<=MAXTAXA; j++) {

		k=j;

		if (s==NULL)
			break;

		if (isdigit(*s)) {		/*** numeric label **/
			k=atol(s);
			if (k<1 || k>ntax || di[k]!=0)
				return MAXTAXA+2;

			s=strtok(NULL," ;");
			if (s==NULL)
				return MAXTAXA+2;
		}

		/*** distribution spec **/
		di[k]=disttono(s);		/*** set di using s **/
		if (di[k]==0)
			return MAXTAXA+1;			/*** erroneous distribution ***/

		x=di[k];	

		for (n=0;x!=0;n++)
			x>>=1;

		if (n>nareas)
			nareas=n;

		s=strtok(NULL," ;");	

	}

	k=j-1;

	if (s!=NULL)
		return MAXTAXA+1;				/*** too many characters in string ***/

	amax=1<<nareas;				/*** success, set amax ***/

	aflag=0;						/*** set aflag **/
	for (j=1; j<=k; j++)
		aflag|=di[j];

	return k;				
}	 									

/*** disttono: convert area string to distribution number ***/
unsigned short disttono (char *s)
{
	unsigned short d,x;
	short c;

	d=0;

	while ((c=*s++)!='\0') {
		c=c-'a';
		if (c<0 || c>=15)
			return 0;			/** erroneous char. in spec. **/
		x=1<<c;
		if (d&x)
			return 0;			/** repeated areas **/
		d|=x;
	}

	return d;
}


/*** printanc: print results from search on file fp ***/
void printanc (FILE *fp, unsigned short *d[])
{
	extern short ntax,*smal,*large;
	extern short min;
	extern char maxareas, taxlabel[][17];
	extern unsigned short keep;
	extern short setbound;
	extern float age,weight;
	extern char printrecs, isheuristic;
	extern short hitnodes;

	unsigned short a,i,j;
	char s[20];
	short lines,position;

	fprintf (fp,"\tsettings: maxareas=%d, bound=%d, hold=%d, weight=%.3f, age=%.3f\n",maxareas,setbound,keep,weight,age);

	if (isheuristic) {
		fprintf (fp, "\thold limit hit for %d node%s\n",hitnodes, (hitnodes==1)? "":"s"); 

		fprintf (fp, "\tbest reconstruction found requires %d costs\n",min, min==1? "":"s"); 
	}
	else
		fprintf (fp, "\toptimal reconstruction requires %d costs\n",min, min==1? "":"s"); 

	fprintf (fp,"\noptimal distributions at each node:\n");

	lines=8;
	for (j=ntax+1; j<2*ntax; j++) {

		if (lines%20==0 && pause(fp))
			return;

		position=fprintf (fp,"node %d (anc. of terminals %s-%s):", j, taxlabel[smal[j]],taxlabel[large[j]]);

		/* JN 03/14/2007 11:05:33 PM CET: Print all reconstructions on one line */
		for (a=0; (i=d[j][a])!=0; a++) {
			notodist (i,s);
			position+=fprintf (fp," %s",s);
		}
		/*
		for (a=0; (i=d[j][a])!=0; a++) {
		notodist (i,s);
		if (position+strlen(s)+2>80) {
		fprintf (fp,"\n");
		position=fprintf (fp," %s",s);
		lines++;
		}
		else if (a==0)
		position+=fprintf (fp," %s",s);
		else
		position+=fprintf (fp," %s",s);
		}
		*/
		fprintf(fp,"\n");

	}

	if (printrecs==1)
		pause(fp);
	else
		fprintf (fp,"\n");

	return;	
}

/*** printrec: print results of reconstruction on file fp ***/
void printrec (FILE *fp)
{
	extern char taxlabel[][17];
	extern short ntax,*smal,*large;
	extern unsigned short nposs;

	short j;
	char s[20];

	fprintf (fp, "\noptimal reconstruction number %i:\n",nposs);

	for (j=ntax+1; j<2*ntax; j++) {

		if ((j-ntax+6)%20==0 && pause(fp))
			return;

		notodist(di[j],s);
		fprintf (fp,"node %d (anc. of terminals %s-%s): %s\n", j, taxlabel[smal[j]],taxlabel[large[j]],s);

	}

	pause(fp);

	return;	
}

/*** command: return no. of command, 0 if illegal ***/
char command (char *s)

{
	const char *clist [] = {"illegal command","help","distribution","echo","noecho",
		"optimize","output","proc","return","tree","quit","reset",
		"sum","rarefy","nodeage","begin","endblock","end","dimensions",
		"matrix","format","charlabels","taxlabels","translate","showareas",
		"showtaxa","utree","exclude",""};

	char i;

	for (i=1; clist[i][0]!='\0';i++) {
		if (!strcmp(clist[i],s))
			return i;
	}
	return 0;
}

/*** option: return no. of option, 0 if illegal ***/
char option (char*s)
{
	const char *clist []= {"illegal option","areas","ambiguous","unambiguous","relative",
		"absolute","classes","interval","sumareas","maxareas",
		"bound","hold","age","weight","status","all","output",
		"seed","nrep","bounds","printrecs","none","keep","enex",""};
	char i;

	for (i=1; clist[i][0]!='\0';i++) {
		if (!strcmp(clist[i],s))
			return i;
	}
	return 0;
}

/*** eprint: print string, add newline character, echo & ask cont. if status is set ***/
char eprint (char *s)
{
	extern FILE *outfile,*infile;
	extern char status,proc;

	if (outfile!=stdout)
		fprintf (outfile,"%s\n",s);

	if (status==1) {
		printf ("%s\n",s);

		if (infile!=stdin || proc==13) {
			printf ("\ado you want to continue (y/n)?\n");
			if (!yes()) {
				if (infile==stdin)
					printf ("rarefaction aborted\n");
				else {
					printf ("procedure aborted - control returned to console\n");
					fclose (infile);
					infile=stdin;
				}
				return 1;
			}
			else			
				printf ("procedure continues\n");	
		}
	}		
	return 0;
}

/*** statprint: print string, add newline character, echo if status is set ***/
void statprint (char *s)
{
	extern FILE *outfile,*infile;
	extern char status;

	if (outfile!=stdout)
		fprintf (outfile,"%s\n",s);

	//if (status==1)
		//printf ("%s\n",s);

	return;
}

/***** optimize: exact optimization, return stat:0 for success*****/
char optimize (void)
{
	/*** MAX=max poss length, keep=no. alternatives to keep at each node **/
	/*** setbound = set max length ***/
	tempgen=tempgen+1;
	*genpoint=tempgen;
	extern char maxareas,echo,sumareas;
	extern short setbound;
	extern unsigned short keep;
	extern short summax;
	extern short nexc;
	extern long amax;
	extern unsigned short *di;
	extern unsigned short *ex;
	extern unsigned short nposs;
	extern short *l,*r;
	extern char ambiguous,isheuristic,classes;
	extern short *tempfreq[];
	extern float *tempvicfreq[][256];
	extern char input[];
	extern short hitnodes;			/*** number of nodes for which hold limit is hit ***/
	extern char intflag;		/** interrupt flag **/

	extern unsigned short *d[MAXLINE/2];
	extern unsigned short *ld[MAXLINE/2];

	unsigned short *lleft, *lright, *ltemp;
	unsigned short j,m,a,allocatedtaxa,ekeep;

	unsigned short ia,ir,il,nright,nleft,nanc,b,e;
	short c;
	short isexc=1;
	long ncomb=0;
	unsigned short bound,upper,lower,maximal,improvedBound,minnode[2*MAXTAXA];

	char stat;

	/** initialize terminals ***/
	for (j=1; j<=ntax; j++) {
		minnode[j]=0;
		d[j]=(unsigned short *) calloc (2,sizeof(unsigned short));
		*d[j]=di[j];
		ld[j]=(unsigned short *) calloc (1,sizeof (unsigned short));
	}
	allocatedtaxa=ntax;

	if (ld[ntax]== NULL) {
		stat=3;
		goto freedld;
	}

	isheuristic=0;    /* mark status of search result ***/
	stat=0; 		 /* assume success */
	hitnodes=0;			/* hold limit not hit */

	ekeep=((keep>KEEPMAX-15)? KEEPMAX : keep+15);	/*** update keep to hold extra one-areas **/

	/****** downpass *****/

	improvedBound=setbound;

	ltemp=(unsigned short*) calloc (amax,sizeof(unsigned short));

	if (ltemp==NULL) {
		stat=3;
		free (ltemp);
		goto freedld;
	}

	if (status==1)
		printf ("optimizing...\n"); /*JN 03/14/2007 11:12:28 PM CET: Include here the 'Ctrl+C' when the 'interrupt()' function is correctly written*/
	if (echo==1)
		printf ("\tdown on node:         ");

	for (j=ntax+1; j<2*ntax;j++) {
		if (echo==1) {
			printf ("\b\b\b\b\b\b\b\b%-3d %3d%%",j,0);
			fflush (stdout);
		}
		for (ia=1; ia<amax; ia++)
			ltemp[ia]=MAX;

		maximal=nposs=0;
		min=MAX;
		min_e=MAX;
		improvedBound=improvedBound+minnode[l[j]]+minnode[r[j]];

		for (ia=1; ia<amax; ia++) {
			a=bits(ia);
			if (a<=maxareas) {
				if (ncomb>1000000) {			/*** suitable interrupt-asking frequency ***/
					ncomb=0;
					if (echo==1) {
						printf ("\b\b\b\b%3d%%",100*ia/32767L);
						fflush (stdout);
					}
				}
				for (nleft=0; (il=d[l[j]][nleft])!=0; nleft++) {
					if ((il&ia)!=0) {
						for (nright=0; (ir=d[r[j]][nright])!=0; nright++){
							isexc=0;
							for (m=0; m<=nexc;m++){
								if (ia==ex[m]){
									isexc=1;
									break;
								}
							}
							if ((ir&ia)!=0 && isexc==0 &&((ia&(ir|il))==ia||enex==1)) {  	 /* possible comb */
								ncomb++;
								b=bits(ir)+bits(il)-bits(ia&(ir|il));		/*  b=cost  */
								e=a-bits(ia&(ir|il));
								b=b+e;
								if (a==1)
									b--;
								b = b + ld[l[j]][nleft] + ld[r[j]][nright];
								c=ltemp[ia];
								if (b<c && b<=improvedBound) {
									ltemp[ia]=b;
									if (b<min)
										min=b;
								}
							}
						}
					}
				}
			}
		}

		minnode[j]=min;
		improvedBound-=min;

		nposs=getno(ltemp,MAX);

		if (nposs==0) {			/*** setbound or MAX too low ***/
			if (echo==1)
				printf ("\n");
			stat=1;
			free (ltemp);
			goto freedld;
		}

		if (j<2*ntax-1) {	/*** not for root node  ***/
			bound=MAX;

			if (nposs>ekeep) {         /*** does not fit ****/
				isheuristic=1;
				hitnodes++;
				for (ia=1; ia<amax; ia++) {      /** find max ***/
					c=ltemp[ia];
					if (c<MAX && c>maximal)
						maximal=c;
				}	
				bound=min+ekeep*(maximal-min)/nposs;
				upper=maximal;
				lower=min;

				while (bound>lower) {
					nposs=getno(ltemp,bound+1);
					if (nposs>ekeep) {
						upper=bound;
						bound=(bound+lower)/2;
					}
					else {
						lower=bound;
						bound=(bound+upper)/2;
					}
				}

				nposs=getno(ltemp,lower+1); 

				if (nposs>ekeep) {	        /*** not possible to fit ***/
					if (echo==1)
						printf ("\n");
					stat=2;
					free (ltemp);
					goto freedld;
				}

				bound=lower+1;		/*** will fit with this bound ***/
			}

			/***** assign distr and lengths to node ****/
			d[j]=(unsigned short *) calloc (nposs+1,sizeof(unsigned short));
			ld[j]=(unsigned short *) calloc (nposs,sizeof(unsigned short));
			allocatedtaxa=j;

			if (ld[j]== NULL) {
				if (echo==1)
					printf ("\n");
				stat=3;
				free (ltemp);
				goto freedld;
			}

			a=0;
			for (ia=1; ia<amax; ia++) {
				c=ltemp[ia];
				if (c<bound) {
					*(ld[j]+a)=c;
					*(d[j]+a)=ia;
					a++;
				}
			}
			/*** always keep one-areas ***/
			for (ia=1; ia<amax; ia=ia<<1) {
				c=ltemp[ia];
				if (c>=bound && c<MAX) {
					*(ld[j]+a)=c;
					*(d[j]+a)=ia;
					a++;
				}
			}				
			*(d[j]+a)=0;	/*** terminate d[j] ***/
		}	 							

	}   /****** next node ****/

	/**** rootsort ******/							

	a=0;
	j=2*ntax-1;

	for (ia=1; ia<amax; ia++) {
		c=ltemp[ia];
		if (c==min)
			a++;
	}

	d[j]=(unsigned short *) calloc (a+1,sizeof(unsigned short));
	ld[j]=(unsigned short *) calloc (a,sizeof(unsigned short));

	allocatedtaxa=j;

	if (ld[j]== NULL) {
		stat=3;
		free (ltemp);
		goto freedld;
	}

	a=0;

	for (ia=1; ia<amax; ia++) {
		c=ltemp[ia];
		if (c==min) {
			*(d[j]+a)=ia;			/*** ld is already initialized by calloc */
			a++;   							
		}
	}

	*(d[j]+a)=0;


	/**** up and final ****/

	free (ltemp);
	lright=(unsigned short *) calloc (ekeep,sizeof(unsigned short));
	lleft=(unsigned short *) calloc (ekeep,sizeof(unsigned short));

	if (lleft== NULL) {
		stat=3;
		free(lright);
		free(lleft);
		goto freedld;
	}

	if (echo==1)
		printf ("\n\tup & final on node:    ");

	ncomb=0;

	for (j=2*ntax-1; j>ntax; j--) {

		if (echo==1) {
			printf ("\b\b\b%-3d",j);
			fflush(stdout);
		}

		for (ia=0; ia<ekeep; ia++)
			*(lleft+ia)=*(lright+ia)=MAX;

		for (nanc=0; (ia=*(d[j]+nanc))!=0; 	nanc++) {
			if (ncomb>1000000) {			/*** suitable interrupt-asking frequency ***/
				ncomb=0;
			}
			for (nleft=0; (il=*(d[l[j]]+nleft))!=0; nleft++)
				if ((il&ia)!=0 && *(ld[l[j]]+nleft)<=min)
					for (nright=0; (ir=*(d[r[j]]+nright))!=0;nright++)
						if ((ir&ia)!=0 && ((ia&(ir|il))==ia || enex==1) && *(ld[r[j]]+nright)<=min) {
							/* poss. comb. */
							ncomb++;
							a=bits(ia);
							b=bits(ir)+bits(il)-bits(ia&(ir|il));		/*  b=cost  */
							e=a-bits(ia&(ir|il));
							b=b+e;
							if (a==1)
								b--;				/* decrease one	if anc in 1 area */					
							b = b + *(ld[j]+nanc);
							b = b + *(ld[l[j]]+nleft);
							b =	b + *(ld[r[j]]+nright);
							if (b==min) {
								*(lright+nright)=min;
								*(lleft+nleft)=min;
							}
						}	
		}

		nleft=nright=0;

		/*** update ldowns to lups and update distr. array ****/ 			

		for (ia=0; *(d[l[j]]+ia)!=0; ia++)
			if (*(lleft+ia)==min) {
				*(d[l[j]]+nleft)=*(d[l[j]]+ia);
				*(ld[l[j]]+nleft)=min - *(ld[l[j]]+ia);
				nleft++;
			}
			*(d[l[j]]+nleft)=0;

			for (ia=0; *(d[r[j]]+ia)!=0; ia++)
				if (*(lright+ia)==min) {
					*(d[r[j]]+nright)=*(d[r[j]]+ia);
					*(ld[r[j]]+nright)=min - *(ld[r[j]]+ia);
					nright++;
				}
				*(d[r[j]]+nright)=0;

	}	/***** next node ****/

	if (echo==1)
		printf ("\n");

	free (lleft);
	free (lright);

	/*** write results ***/

	if (isheuristic)
		statprint ("optimization successful - heuristic solution");
	else
		statprint ("optimization successful - exact solution");

	if (outfile!=stdout)
		printanc (outfile,d);

	if (echo==1) {
		printanc (stdout,d);
	}

	if (intflag) {
		stat=5;
		goto freedld;
	}

	nposs=0;

	if (stat==0 && (sumareas>0 || printrecs)) {			/*** only if necessary  **/

		/**** add results to counters ***/

		if (status==1)
			printf ("retrieving alternative reconstructions...\n\tpress command-period (Mac) or 'B' (Win) to stop\n");

		if (ambiguous)
			equis();
		else
			unambiguous();

		if (intflag)
			stat=5;
		else {
			transfer();

			if (nposs==1)
				sprintf(input,"\nthere is only one optimal reconstruction");
			else
				sprintf(input,"\nthere are %i alternative, equally optimal reconstructions",nposs);

			if (outfile!=stdout)
				fprintf (outfile,"%s\n",input);

			if (echo)
				printf ("%s\n",input);

			statprint ("results added to counters");
		}
	}

freedld:

	for (j=1; j<=allocatedtaxa; j++) {
		free (d[j]);
		free (ld[j]);
	}

	return stat;

}				


/**** getno: get no. of lengths shorter than bound   *****/
unsigned short getno(unsigned short *p, unsigned short bound)
{
	extern long amax;
	unsigned short i,n;
	short a;

	n=0;

	for (i=1;i<amax;i++) {
		a=*(p+i);
		if (a<bound)
			n++;
	}

	for (i=1;i<amax;i<<=1) {
		a=*(p+i);
		if (a>=bound && a<MAX)
			n++;
	}
	return n;
}	    							


/***** equis: get alternative reconstructions ***/
void equis (void)
{
	extern unsigned short nposs;
	extern unsigned short *di;
	extern short min;
	extern short enex;
	extern unsigned short *d[];
	extern unsigned short *ld[];
	extern char intflag;
	
	short len,c,step[MAXLINE/2],e;
	unsigned short a,j,pos[MAXLINE/2];
	
	j=ntax+1;
	pos[j]=0;
	step[j-1]=len=0;
	
start:
	
	len=step[j-1];
	
	if ((a=d[j][pos[j]++])==0) {
		if (j==ntax+1)
			return;				/** no more possibilities **/
		j--;
		goto start;
	}
	
	if ((a&di[l[j]])!=0 && (a&di[r[j]])!=0 && ((a&(di[l[j]]|di[r[j]]))==a||enex==1)) {
		c=bits(di[l[j]])+bits(di[r[j]])-bits(a);
		e=bits(a)-bits((di[l[j]]|di[r[j]])&a);
		c=c+e;
		if (bits(a)==1)
			c--;
		if ((c+len)<=min) {
			di[j]=a;
			len+=c;
			step[j]=len;
			if (j==(2*ntax-1)) {
				nposs++;
				if (sum())
					return;
				if (printrecs) {
					if (outfile!=stdout)
						printrec (outfile);
					if (echo==1) {
						printrec (stdout);
						if (intflag)
							return;
					}	
				}
				j--;
				goto start;
			}
			pos[++j]=0;
			goto start;
		}
	}
	goto start;				
}

/*** area: return position of rightmost bit set in b, from 0 to 15; 0 if b=0 ***/
char area (unsigned short b)
{
	char c;

	for (c=0; b!=0; c++) {
		if (b&1)
			break;
		b>>=1;
	}

	return c;
}

/*** sum: sum results for one possible reconstruction, ambiguous or unambiguous ***/
char sum(void)
{
	extern unsigned short *di;
	extern short ntax,summax;
	extern short *r,*l;
	extern short *tempfreq[];
	extern char *nodeclass;

	unsigned short j;
	char a;

	for (j=2*ntax-1; j>ntax; j--) {

		a=nodeclass[j];

		if (di[j]<summax) {
			tempfreq[a][di[j]]++;		/*** count distribution frequency ***/
			if (bits(di[j])>2 && bits(di[l[j]])+bits(di[r[j]])>0)
				vicariance (a-1,di[j],di[l[j]],di[r[j]]);	/** vicariance freq. **/
		}

		if (bits(di[l[j]])==2)		/*** count costs on left branch **/
			moveadd(a-1,di[j],di[l[j]],di[r[j]]);

		if (bits(di[r[j]])==2)		/*** count costs on right branch **/
			moveadd(a-1,di[j],di[r[j]],di[l[j]]);

	}
	/*	if (interrupt() && OKStop())			*/
	/*		return 1;*/
	/*	else*/
	return 0;
}

/**** moveadd: add costs if any between a (anc) and b (desc) ***/
/**** considering c (other descendant of a) segment=age segment of a *****/
void moveadd(char segment,unsigned short a, unsigned short b, unsigned short c)
{
	extern float *tempmove[16][16];
	char ub,uc,d,e;

	if (bits(a&b)==1)			/**** 1 common area with ancestor ***/
		(*(tempmove[area(a&b)][area(b&(a^b))]+segment))++;
	else {    					 /**** 2 common areas ***/
		ub=2-bits(a&b&c);		
		uc=bits(a&c)-bits(a&b&c);
		d=area(a&b&c);
		e=area(b&~(1<<d));
		switch (ub) {
		case 0:					/**** b's areas also in c ***/
			if (uc==0) {				/*** same areas in b and c ***/
				(*(tempmove[d][e]+segment))+=0.50;
				(*(tempmove[e][d]+segment))+=0.50;
			}
			else {							/*** additional areas shared by a&c ***/
				(*(tempmove[d][e]+segment))+=(1.0/3.0);	/*** both b areas inherited also possible **/				
				(*(tempmove[e][d]+segment))+=(1.0/3.0);
			}
			break;
		case 1:								/*** 1 area (=d) in b also in c ***/		
			if (uc==0)						/*** d only area shared by a&c ***/
				(*(tempmove[e][d]+segment))+=1.0;
			if (uc!=0)			/*** additional areas shared by a&c ***/
				(*(tempmove[e][d]+segment))+=0.5;

		}	/*** if case 2 (not in c or ambiguous in a, b or c) then no dispersal ***/
	}
}



/*** transfer: transfer temporary results to counters,initialize temps ***/
void transfer (void)
{
	extern short ntax,summax;
	extern unsigned short nposs;
	extern float *move[16][16],*freq[],*vicfreq[][256];
	extern float weight,terms,ancs,disps,ntrees;
	extern float *tempmove[16][16], *tempvicfreq[][256];
	extern short *tempfreq[];
	extern unsigned short aflag,sumaflag;
	extern long amax;
	extern char nareas;

	char a,b;	
	unsigned short c,d,i,j;

	for (a=0; a<nareas;a++)
		for (b=0;b<nareas;b++) 
			for (j=0;j<classes;j++) {
				move[a][b][j]+=(tempmove[a][b][j]*weight/(float)nposs);
				tempmove[a][b][j]=0;
			}

			c=(amax<summax)? amax : summax;

			for (j=1;j<=classes;j++)				/*** transfer **/
				for (d=0; d<c; d++) {
					freq[j][d]+=(tempfreq[j][d]*weight/(float)nposs);
					tempfreq[j][d]=0;
					if ((b=bits(d))>2)
						for (i=1; i<(1<<(b-1));i++) {
							vicfreq[j-1][d][i]+=(tempvicfreq[j-1][d][i]*weight/(float)nposs);
							tempvicfreq[j-1][d][i]=0;
						}
				}					

				for (j=1;j<=ntax;j++)
					if (di[j]<summax)
						freq[0][di[j]]+=weight;

				sumaflag|=aflag;

				ntrees+=weight;
				ancs+=(weight*(ntax-1));
				terms+=(weight*ntax);
				disps+=(weight*min);
}

/*** printsum: print summary statistics on file fp for x areas ***/
void printsum(FILE *fp,char x)
{
	extern float terms,ancs,disps,limit[];
	extern float *move[16][16],*freq[];
	extern FILE *outfile, *infile;
	extern long amaxhigh;
	extern char absolute,intflag,integer;

	unsigned short a,b,i,j,nomax,left,right;
	char c,lines, s[20],sright[20],sleft[20],temp[100];
	float f,g[7],h[7],m[7],n[7][8];

	nomax=1<<x;

	fprintf (fp,"Summary options:\n");
	fprintf (fp,"\tNumber of areas considered: %i\n",x);
	if (nomax<amaxhigh)
		fprintf (fp,"\tNB! additional areas present in terminals\n");
	if (ambiguous)
		fprintf (fp,"\tAmbiguous events included\n");
	else
		fprintf (fp,"\tOnly unambiguous events included");
	fprintf (fp,"\tNumber of time classes: %i\n",classes);
	if (classes>1) {
		if (absolute)
			fprintf(fp,"\tAbsolute time classes (speciations from terminals)\n");
		else
			fprintf(fp,"\tRelative time classes\n");

		fprintf(fp,"\tClass bounds: ");

		if (integer) {
			for (c=1;c<classes;c++) {
				if (limit[c]-limit[c-1]==1)
					fprintf(fp,"%i, ",(int)limit[c]);
				else
					fprintf(fp,"%i-%i, ",(int)limit[c-1]+1,(int)limit[c]);
			}
			fprintf (fp, "%i-\n",(int)limit[c-1]+1);
		}
		else {										/*** floats ***/
			for (c=1;c<classes;c++)
				fprintf (fp,"<%.2f, ",limit[c]);
			fprintf (fp, ">%.2f\n",limit[c-1]);
		}
	}
	if (pause(fp))
		goto endsum;

	lines=3;

	fprintf (fp,"\nFREQUENCY OF DISTRIBUTIONS\n");
	fprintf (fp,"Distribution\t");
	if (classes==1)
		fprintf (fp," Term.\t  Anc.\n");
	else {
		lines++;
		if (absolute) {
			fprintf (fp,"Frequency in time segment (absolute time)\n            \t");
			fprintf (fp," Term.\t");
		}
		else {					/*** relative ***/
			fprintf (fp,"Frequency in time segment (relative time)\n            \t");
			fprintf (fp," Term.\t");
		}
		if (integer) {
			for (c=1;c<classes;c++) {
				if (limit[c]-limit[c-1]==1)
					fprintf(fp,"%4i\t",(int)limit[c]);
				else
					fprintf(fp,"%3i-%i\t",(int)limit[c-1]+1,(int)limit[c]);
			}
			fprintf (fp, "%3i- \tAll anc.\n",(int)limit[c-1]+1);
		}
		else {					/*** floats ***/
			for (c=1;c<classes;c++)
				fprintf (fp," <%.2f\t",limit[c]);
			fprintf (fp, " >%.2f \tAll anc.\n",limit[c-1]);
		}
	}

	f=0;							/*** reset summary variables ***/

	for (c=0;c<=(classes+1);c++) {
		g[c]=h[c]=m[c]=0;
		for (i=0;i<x;i++)
			n[c][i]=0;
	}

	for (a=1;a<nomax;a++) {
		notodist (a,s);
		sprintf(temp,"%-12s\t%7.3f\t",s,freq[0][a]);
		g[0]+=freq[0][a];
		h[0]+=freq[0][a]*bits(a);
		if (bits(a)>1)
			m[0]+=freq[0][a];
		for (i=j=1;i<=x;i++) {
			if (a&j)
				n[0][i-1]+=freq[0][a];
			j<<=1;
		}
		for (c=1;c<=classes;c++) {
			sprintf (s,"%7.3f\t",freq[c][a]);
			strcat (temp,s);
			g[c]+=freq[c][a];
			h[c]+=freq[c][a]*bits(a);
			if (bits(a)>1)
				m[c]+=freq[c][a];
			for (i=j=1;i<=x;i++) {
				if (a&j)
					n[c][i-1]+=freq[c][a];
				j<<=1;
			}
			f+=freq[c][a];
		}
		if (classes>1) {
			sprintf (s,"%7.3f",f);
			strcat (temp,s);
		}
		g[c]+=f;
		h[c]+=f*bits(a);
		if (bits(a)>1)
			m[c]+=f;
		for (i=j=1;i<=x;i++) {
			if (a&j)
				n[c][i-1]+=freq[c][a];
			j<<=1;
		}
		if (f!=0 || freq[0][a]!=0) {
			fprintf (fp,"%s\n",temp);
			lines++;
		}

		f=0;
		if (lines>=20) {
			if (pause (fp))
				goto endsum;
			lines=0;
		}
	}

	fprintf (fp,"Total      \t");
	for (c=0; c<=classes; c++)
		fprintf (fp,"%7.3f\t",g[c]);
	if (classes>1)
		fprintf (fp,"%7.3f\t",g[c]);
	fprintf (fp,"\n");

	fprintf (fp,"Mean # areas\t");
	for (c=0; c<=classes; c++)
		if (g[c]==0)
			fprintf (fp,"%7.3f\t",0);
		else
			fprintf (fp,"%7.3f\t",h[c]/g[c]);
	if (classes>1)
		if (g[c]==0)
			fprintf (fp,"%7.3f",0);
		else
			fprintf (fp,"%7.3f",h[c]/g[c]);
	fprintf (fp,"\n");

	fprintf (fp,"Vicar. ratio\t   -   \t");
	for (c=1; c<=classes; c++)
		if (g[c]==0)
			fprintf (fp,"%7.3f\t",0);
		else
			fprintf (fp,"%7.3f\t",m[c]/g[c]);
	if (classes>1)
		if (g[c]==0)
			fprintf (fp,"%7.3f",0);
		else
			fprintf (fp,"%7.3f",m[c]/g[c]);
	fprintf (fp,"\n");


	if (pause(fp))
		goto endsum;

	f=i=0;
	lines=3;

	fprintf (fp,"\nSPECIES RICHNESS\n");
	fprintf (fp,"Area \t");
	if (classes==1)
		fprintf (fp," Term.\t  Anc.\n");
	else {
		lines++;
		if (absolute) {
			fprintf (fp,"Frequency in time segment (absolute time)\n     \t");
			fprintf (fp," Term.\t");
		}
		else {					/*** relative ***/
			fprintf (fp,"Frequency in time segment (relative time)\n     \t");
			fprintf (fp," Term.\t");
		}
		if (integer) {
			for (c=1;c<classes;c++) {
				if (limit[c]-limit[c-1]==1)
					fprintf(fp,"%4i\t",(int)limit[c]);
				else
					fprintf(fp,"%3i-%i\t",(int)limit[c-1]+1,(int)limit[c]);
			}
			fprintf (fp, "%3i- \tAll anc.\n",(int)limit[c-1]+1);
		}
		else {					/*** floats ***/
			for (c=1;c<classes;c++)
				fprintf (fp," <%.2f\t",limit[c]);
			fprintf (fp, " >%.2f \tAll anc.\n",limit[c-1]);
		}
	}


	f=0;
	for (c=0;c<=classes+1;c++)
		g[c]=0;

	for (a=0;a<x;a++) {
		sprintf (temp,"%c    \t%7.3f\t",a+'A',n[0][a]);
		g[0]+=n[0][a];
		for (c=1;c<=classes;c++) {
			sprintf (s,"%7.3f\t",n[c][a]);
			strcat (temp,s);
			g[c]+=n[c][a];
			f+=n[c][a];
		}
		if (classes>1) {
			sprintf (s,"%7.3f",f);
			strcat (temp,s);
		}
		g[c]+=f;

		if (f!=0 || n[0][a]!=0) {
			fprintf (fp,"%s\n",temp);
			lines++;
		}

		f=0;
		if (lines>=20) {
			if (pause (fp))
				goto endsum;
			lines=0;
		}
	}

	fprintf (fp,"Total\t");
	for (c=0; c<=classes; c++)
		fprintf (fp,"%7.3f\t",g[c]);
	if (classes>1)
		fprintf (fp,"%7.3f\t",g[c]);
	fprintf (fp,"\n");

	if (pause(fp))
		goto endsum;	

	fprintf (fp,"\nCOSTS BETWEEN SINGLE AREAS\n");
	fprintf (fp,"From\tTo\t");
	if (classes==1)
		fprintf (fp,"Frequency\n");
	else {
		lines++;
		if (absolute)
			fprintf (fp,"Frequency in time segment (absolute time)\n   \t \t");
		else					/*** relative ***/
			fprintf (fp,"Frequency in time segment (relative time)\n   \t \t");
		if (integer) {
			for (c=1;c<classes;c++) {
				if (limit[c]-limit[c-1]==1)
					fprintf(fp,"%4i\t",(int)limit[c]);
				else
					fprintf(fp,"%3i-%i\t",(int)limit[c-1]+1,(int)limit[c]);
			}
			fprintf (fp, "%3i- \tAll anc.\n",(int)limit[c-1]+1);		
		}
		else {					/*** floats ***/
			for (c=1;c<classes;c++)
				fprintf (fp," <%.2f\t",limit[c]);
			fprintf (fp, " >%.2f \tAll anc.\n",limit[c-1]);
		}
	}

	f=0;
	for (c=0;c<=classes;c++)
		g[c]=0;

	for (a=0;a<x;a++)
		for (b=0;b<x;b++)
			if (b!=a) {
				sprintf (temp,"%c   \t%c \t",a+'A',b+'A');
				for (c=0;c<classes;c++) {
					sprintf (s,"%7.3f\t",move[a][b][c]);
					strcat (temp,s);
					g[c]+=move[a][b][c];
					f+=move[a][b][c];
				}
				if (classes>1) {
					sprintf (s,"%7.3f",f);
					strcat (temp,s);
				}

				g[c]+=f;

				if (f!=0) {
					fprintf (fp,"%s\n",temp);
					lines++;
				}

				f=0;

				if (lines>=20) {
					if (pause (fp))
						goto endsum;
					lines=0;
				}
			}

			if (g[classes]==0)
				fprintf (fp,"No costs recorded\n");
			else {
				fprintf (fp,"Total   \t");
				for (c=0; c<classes; c++)
					fprintf (fp,"%7.3f\t",g[c]);
				if (classes>1)
					fprintf (fp,"%7.3f\t",g[c]);
				fprintf (fp,"\n");
			}

			if (pause(fp))
				goto endsum;	

			f=i=0;
			lines=3;

			if (x>2) {

				fprintf (fp,"\nFREQUENCY OF VICARIANCE EVENTS (INVOLVING MORE THAN 2 AREAS)\n");
				fprintf (fp,"Event    \t");
				if (classes==1)
					fprintf (fp,"Frequency\n");
				else {
					lines++;
					if (absolute)
						fprintf (fp,"Frequency in time segment (absolute time)\n         \t");
					else					/*** relative ***/
						fprintf (fp,"Frequency in time segment (relative time)\n         \t");
					if (integer) {
						for (c=1;c<classes;c++) {
							if (limit[c]-limit[c-1]==1)
								fprintf(fp,"%4i\t",(int)limit[c]);
							else
								fprintf(fp,"%3i-%i\t",(int)limit[c-1]+1,(int)limit[c]);
						}
						fprintf (fp, "%3i- \tAll anc.\n",(int)limit[c-1]+1);
					}
					else {					/*** floats ***/
						for (c=1;c<classes;c++)
							fprintf (fp," <%.2f\t",limit[c]);
						fprintf (fp, " >%.2f \tAll anc.\n",limit[c-1]);
					}
				}

				f=0;
				for (c=0;c<=classes;c++)
					g[c]=0;

				for (a=1;a<nomax;a++)
					if (bits(a)>2) {
						for (b=1;b<(1<<(bits(a)-1));b++) {
							left=vnotoa(b,a);
							right=a^left;
							notodist(left,sleft);
							notodist(right,sright);
							strcat(sleft,"-");
							strcat(sleft,sright);
							sprintf (temp,"%-9s\t",sleft);
							for (c=0;c<classes;c++) {
								sprintf (s,"%7.3f\t",vicfreq[c][a][b]);
								strcat (temp,s);
								g[c]+=vicfreq[c][a][b];
								f+=vicfreq[c][a][b];
							}
							if (classes>1) {
								sprintf (s,"%7.3f",f);
								strcat (temp,s);
							}

							g[c]+=f;

							if (f!=0) {
								fprintf (fp,"%s\n",temp);
								lines++;
							}

							f=0;

							if (lines>=20) {
								if (pause (fp))
									goto endsum;
								lines=0;
							}
						}
					}

					if (g[classes]==0)
						fprintf (fp,"No vicariance events recorded\n");
					else {
						fprintf (fp,"Total    \t");
						for (c=0; c<classes; c++)
							fprintf (fp,"%7.3f\t",g[c]);
						if (classes>1)
							fprintf (fp,"%7.3f\t",g[c]);
						fprintf (fp,"\n");
					}
					if (pause (fp))
						goto endsum;	
			}
			fprintf (fp,"\nSummary tree statistics\n");
			fprintf (fp,"\tTotal number of trees: %.3f\n",ntrees);
			fprintf (fp,"\tTotal number of terminals: %.3f\n",terms);
			fprintf (fp,"\tTotal number of speciations: %.3f\n",ancs);
			fprintf (fp,"\tTotal number of costs: %.3f\n",disps);

endsum:

			return;
}

/**** unambiguous: put unambiguous anc distr in di[j], zero if ambiguous ***/
void unambiguous (void)
{
	extern unsigned short *di;
	extern unsigned short nposs;

	short j;

	nposs=1;

	for (j=ntax+1; j<2*ntax; j++) {
		if (d[j][1]==0)
			di[j]=d[j][0];		/** unambiguous assignment ***/
		else
			di[j]=0;			/** ambiguous assignment, set di[j] to zero **/
	}

	sum();

	return;
}

/*** notodist: transform distribution number in a to distribution string in s ***/
void notodist (unsigned short a, char * s)
{
	char b;
	unsigned short c;

	c=1;

	for (b=0; b<15; b++) {

		if (a&c)

			*s++='A'+b;

		c<<=1;
	}

	*s='\0';

	return;
}

/*** vicariance: record frequency of vicariance events for >2areas ***/
void vicariance (char segment,unsigned short a, unsigned short b, unsigned short c)
{
	extern float *tempvicfreq[][256];

	short vicposs,common;
	unsigned short i,j,k[16],distmin, uniqueleft, uniqueright, left, right,shared;

	uniqueleft=a&b&(~c);
	uniqueright=a&c&(~b);
	shared=a&b&c;

	common=bits(shared);

	if (common==0) {
		distmin=(uniqueleft<uniqueright) ? uniqueleft : uniqueright;
		distmin=atovno(distmin,a);
		tempvicfreq[segment][a][distmin]+=1.0;
	}
	else {

		vicposs=(1<<common);

		if ((bits(b)-bits(b&shared))==0)
			vicposs--;
		if ((bits(c)-bits(c&shared))==0)
			vicposs--;

		i=0;
		for (j=shared; j!=0; j&=(j-1))
			k[i++]=(1<<area(j));

		for (i=0; i<(1<<common);i++) {

			j=0;

			left=uniqueleft;

			for (c=i; c!=0; c>>=1) {
				if (c&1)
					left=left|k[j];
				j++;
			}

			right=a^left;

			distmin=(left<right)? left:right;
			distmin=atovno(distmin,a);
			tempvicfreq[segment][a][distmin]+=(1.0/(float) vicposs);		

		}

	}

	return;
}

/*** intoa: convert n to characters in s, n must be positive ***/		
void intoa (int n, char *s)
{
	char i,j,c;

	i=0;

	do {
		s[i++]=n%10+'0';
	} while ((n/=10)>0);

	s[i--]='\0';

	for (j=0;j<(i+1)/2;j++) {
		c=s[j];
		s[j]=s[i-j];
		s[i-j]=c;
	}	

}

/*** OKStop: ask if stop, set and return intflag if OK ***/
int OKStop(void)
{
	extern char intflag;
	extern FILE *infile;

	if (infile==stdin)
		printf( "\ado you want to stop processing of the command? (y or n)\n");
	else
		printf( "\ado you want to abort the procedure? (y or n)\n");

	if (yes())
		intflag=1;
	else {
		intflag=0;
		if (infile==stdin)
			printf ("processing of command continues\n");
		else
			printf ("procedure continues\n");
	}

	return intflag;
}

/*** OKExit: ask if exit, return if not, otherwise exit ***/
void OKExit(int sig)
{
	signal (sig, ignore);

	printf( "\ado you want to exit the program? (y or n)\n");
	if (yes())
		exit(0);

	printf("execution resumed\n");

	signal (sig,OKExit);

	return;
}

/*** vnotoa: convert vic. event n of ancestral dist. a to smalest vic. dist **/
unsigned short vnotoa (unsigned short n, unsigned short a)
{
	unsigned short j,area[16];

	char i;

	i=0;
	for (j=1; j<amax;j<<=1) {
		if (a&j)
			area[i++]=j;
	}

	for (i=j=0;n!=0;n>>=1) {
		if (n&1)
			j+=area[i];
		i++;
	}

	return j;
}

/*** atovno: convert smalest vic. dist. of ancestral dist. a to vic. event no. **/		
unsigned short atovno (unsigned short b, unsigned short a)
{
	unsigned short x,n;

	n=0;
	for (x=1;b!=0;b>>=1) {
		if (a&1) {
			if (b&1)
				n|=x;
			x<<=1;
		}
		a>>=1;
	}
	return n;
}

/*** agetoclass: convert nodeage to nodeclass ***/
void agetoclass (void)
{
	extern float *nodeage;
	extern char *nodeclass,absolute;
	extern float age;
	extern float limit[];

	short j;
	char b;

	for (j=ntax+1; j<2*ntax; j++) {
		if (absolute) {
			for (b=classes-1; nodeage[j]<=limit[b];b--)
				;
			nodeclass[j]=b+1;
		}
		else {
			for (b=classes-1; (nodeage[j]*age/(nodeage[2*ntax-1]))<=limit[b];b--)
				;
			nodeclass[j]=b+1;
		}
	}
}		

/*** matrix: set distributions according to matrixstring, return 0 if success, 1 if failure ***/
char matrix (char *s)
{
	extern unsigned short *di;
	extern char taxlabel[][17], charlabel[][17];
	extern char nareas;
	extern short ntax;
	extern char transpose;
	extern long amax;

	unsigned short x;
	short j,k,n;

	/*** reset di[] ***/

	for (j=1; j<=ntax; j++)
		di[j]=0;

	if (transpose==TRUE) {

		/*** transpose ***/

		for (j=1; j<=nareas; j++) {

			s=strtok(s," ;");

			if (s==NULL)
				return 1;

			strncpy (charlabel[j],s,16);
			charlabel[j][16]='\0';

			s=strtok(NULL,";");

			if (s==NULL)
				return 1;

			x=1<<(j-1);

			for (k=1; k<=ntax; k++) {

				while (!isdigit(*s)) {
					if (isgraph(*s))
						return 1;
					s++;
				}

				if (*s!='0' && *s!='1')
					return 1;

				if (*s=='1')
					di[k]=di[k]+x;

				s++;
			}
		}
	}
	else {

		/** notranspose ***/

		for (j=1; j<=ntax; j++) {

			s=strtok(s," ;");

			if (s==NULL || !isalpha(*s))
				return 1;

			strncpy (taxlabel[j],s,16);
			taxlabel[j][16]='\0';

			s=strtok(NULL,";");

			if (s==NULL)
				return 1;

			for (k=1; k<=nareas; k++) {

				while (!isdigit(*s)) {
					if (isgraph(*s))
						return 1;
					s++;
				}

				if (*s!='0' && *s!='1')
					return 1;

				x=1<<(k-1);

				if (*s=='1')
					di[j]=di[j]+x;

				s++;
			}
		}
	}

	/*** find nareas; check if distribution empty ***/

	for (j=1;j<=ntax;j++) {
		x=di[j];	

		if (x==0)
			return 1;			/*** distribution is empty !!! ***/

		for (n=0;x!=0;n++)
			x>>=1;

		if (n>nareas)
			nareas=n;

	}

	if ((s=strtok(s," ;"))!=NULL)
		return 1;
	else {
		amax=1<<nareas;				/*** success, set amax ***/

		aflag=0;						/*** set aflag **/
		for (j=1; j<=k; j++)
			aflag|=di[j];
	}

	return 0;		/*** success ***/
}

/*** charlabels: set charlabels, return no. set ***/
char charlabels (char *s)
{
	extern char charlabel[][17];

	char j;

	for (j=1; j<=15; j++) {

		if (j==1)
			s=strtok(s," ;");
		else
			s=strtok(NULL," ;");

		if (s==NULL)
			return j-1;

		strncpy (charlabel[j],s,16);
		charlabel[j][16]='\0';
	}

	if ((s=strtok(NULL," ;"))!=NULL)
		return 16;
	else
		return 16;
}

/*** taxlabels: set taxlabels, return no. set ***/
short taxlabels (char *s)
{
	extern char taxlabel[][17];

	short j;

	for (j=1; j<=MAXTAXA; j++) {

		if (j==1)
			s=strtok(s," ;");
		else
			s=strtok(NULL," ;");

		if (s==NULL)
			return j-1;

		if (!isalpha(*s))
			return MAXTAXA+1;

		strncpy (taxlabel[j],s,16);
		taxlabel[j][16]='\0';

	}

	if ((s=strtok(NULL," ;"))!=NULL)
		return MAXTAXA+1;
	else
		return MAXTAXA+1;
}

/*** translate: set tokenlabels, return no. set, MAXTAXA+1 if failure ***/
short translate (char *s)
{
	extern char tokenlabel[][17];
	extern char taxlabel[][17];
	extern short ntax;

	short j,k;
	char *t;

	/*** clear tokenlabels ***/

	for (j=1; j<=ntax;j++)
		tokenlabel[j][0]='\0';

	for (j=1; j<=ntax; j++) {

		if (j==1)
			s=strtok(s," ;,");
		else
			s=strtok(NULL," ;,");

		if (s==NULL)
			break;

		t=strtok(NULL," ;,");

		if (t==NULL)
			return MAXTAXA+1;

		for (k=1;k<=ntax; k++) {
			if (strncmp(taxlabel[k],t,16)==0)
				break;
		}
		if (k>ntax || *tokenlabel[k]!='\0')
			return MAXTAXA+1;

		strncpy (tokenlabel[k],s,16);
		tokenlabel[k][16]='\0';

	}

	if (s!=NULL && (s=strtok(NULL," ;"))!=NULL)
		return MAXTAXA+1;

	for (k=1; k<=ntax; k++)				/*** set remaining, if any, to default ***/
		if (*tokenlabel[k]=='\0')
			intoa(k,tokenlabel[k]);
	return j-1;
}

/*** showareas ***/
void showareas (FILE *fp)
{
	char c;

	fprintf (fp,"Area\tLabel\n");
	for (c=0;c<15;c++)
		fprintf (fp,"%c    \t%s\n",'A'+c,charlabel[c+1]);
	fprintf (fp,"\n");
}

/*** showtaxa ***/
void showtaxa (FILE *fp)
{
	short i;

	fprintf (fp,"No.\tTaxon\n");
	for (i=1;i<=ntax;i++) {
		fprintf (fp,"%i\t%s\n",i,taxlabel[i]);
		if ((i+1)%20==0 && pause(fp))
			return;
	}		
	fprintf(fp,"\n");

}

/*** ignore ***/
void ignore(int sig)
{
	signal (sig,ignore);
	intflag=1;

	return;
}
char pause (FILE *);

/*** setup: setup console ***/
void setup (void)
{
	return;
}

/**** interrupt: return 1 if interrupt requested, else 0 ****/
char interrupt (void)
{
	return 0;

}

/***** pause: check for interrupt; pause if stdout *****/
char pause (FILE *fp)
{

	return intflag;
}

/*** halt: pause between batch commands ***/
char halt (void)
{

	return intflag;
}	
char yes(void)
{
	return '1';
}

char pause (FILE *);
char help(unsigned long b,FILE *fp);

static char *line [18][40];

/*** help: print help for commands flagged in b, return 1 if interrupt, 0 if success ***/
char help(unsigned long b,FILE *fp)
{
	return 0;
}


// This is an example of an exported variable
DIVADLL_API int nDIVADLL=0;

// This is an example of an exported function.
DIVADLL_API int fnDIVADLL(char a[])
{
	return a[1] ;
}

// This is the constructor of a class that has been exported.
// see DIVADLL.h for the class definition
CDIVADLL::CDIVADLL()
{
	return;
}
