#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <limits.h>
#include <float.h>

/*YY 09/01/2014 8:45:48 PM CET*/
/*JN 12/11/2007 10:07:08 PM CET*/
/*Bayes-DIVA*/


/*#pragma once*/

/*** define magic numbers  ****/

#define MAX 32767  		/*** unsigned short. indicating impossibility  ***/
#define KEEPMAX 32767   /**** max. no. alternatives to keep at each node ***/ 
#define MAXLINE 32767	/**** max input line ***/ /* JN */
#define MAXTAXA 1024		/*** max. no. taxa ***/ /* JN */
#define MAXEXC 32767
#define	DIVABLOCK 0		/*** block markers ***/
#define	DATABLOCK 1
#define	TREEBLOCK 2
#define FOREIGNBLOCK 3
#define OUTOFBLOCK 4
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

/***  function prototypes ***/

char help(unsigned long,FILE *);
char instring (FILE *, char *);
char rarefy(unsigned short);
unsigned short stringtotree (char *); /*JN. 12/11/2007 09:39:41 PM CET. Changed the return type. */
/*char stringtotree (char *);*/
short distribution (char *);
short exclude (char *);
unsigned short disttono (char *);
void printanc(FILE *, unsigned short *d[]);
void printrec (FILE *);
char command (char *);
char option (char *);
char eprint (char *);
void statprint (char *);
char optimize (void);
unsigned short getno (unsigned short *, unsigned short);
void equis (void);
char area (unsigned short);
char sum(void);
void moveadd(char, unsigned short, unsigned short, unsigned short);
void transfer (void);
void printsum (FILE *,char);
void unambiguous (void);
void notodist (unsigned short, char *);
char pause (FILE *);
void vicariance (char, unsigned short, unsigned short, unsigned short);
void intoa (int n, char *s);
void OKExit(int sig);
int OKStop(void);
void sigHandler (int sig);
unsigned short atovno (unsigned short b, unsigned short a);
unsigned short vnotoa (unsigned short n, unsigned short a);
void agetoclass (void);
char interrupt (void);
char yes (void);
char matrix (char *s);
char charlabels (char *s);
short taxlabels (char *s);
short translate (char *s);
void showareas (FILE *fp);
void showtaxa (FILE *fp);
void ignore (int sig);
void setup();
char halt (void);

/***  global variables  ***/

FILE *infile, *outfile,*rarein,*rareout;		/*** file pointers ***/
char echo,status,tree,dist,isheuristic,ambiguous;   /** status variables **/
char input[MAXLINE+1]; 								 /** input variable **/
char nareas,maxareas,nareashigh,printrecs,proc;			 /** status variables **/
short ntax;					    		 /** number of taxa in last tree or distribution **/
short nexc;								/** number of excluded taxon in last tree or distribution **/
short enex;								/** enable extinction **/
long amax,amaxhigh;  				 /*** max distribution number ***/
short *l, *r, *root,*smal,*large;   /*** tree globals ***/
float *nodeage;						/*** tree global **/
char *nodeclass;					/*** tree global **/
short min;  /**** optimal reconstruction length  ****/
short min_e;  /**** optimal reconstruction length  ****/
unsigned short *di;    /*** observed & reconstructed distributions (one poss.) ****/
unsigned short *ex;
short setbound;   /*** set reconstruction length ***/
unsigned short keep;     /**** number of alternative reconstructions to keep ***/
float *move[16][16], *tempmove[16][16];		/*** dispersals ***/
float terms, ancs, disps,ntrees;     /*** counters for summary statistics ***/
float weight;			/*** weight to be applied to each optimization ***/
float age; 				/*** relative age of a clade ***/
float *freq[6];			/*** frequency of distributions in time intervals ***/	
short *tempfreq[6];				/*** temporary summary variable ***/
float *tempvicfreq[5][256];		/*** temporary summary variable ***/
unsigned short nposs;		/*** number of reconstructions **/
char absolute,classes,sumareas,integer;	/*** status variables **/
short summax;			 /***max distribution number +1 corr. to sumareas ***/
float interval;					/*** segment bounds variable ***/
char taxlabel[MAXTAXA+1][17];		/*** taxon labels ***/
/*char taxlabel[MAXTAXA+1][MAXTAXLABEL];*/ /* JN */
char tokenlabel[MAXTAXA+1][17];		/*** token labels ***/
/*char tokenlabel[MAXTAXA+1][MAXTAXLABEL];*/ /* JN */
char charlabel[16][17];				/*** area labels ***/
char intflag;				/*** interrupt flags **/
float *vicfreq[5][256];				/*** summary variable ***/
float limit[6];					/*** segment bounds variable ***/
unsigned short *d[MAXLINE/2];		/*** optimize variables ***/
unsigned short *ld[MAXLINE/2];		/*** optimize variables ***/
short nrep;							/*** variable for rarefy ***/
unsigned short aflag, sumaflag;		/*** areas in dist, areas summed ***/
char tokenset, taxlabelset;		/*** indicate whether taxon- or tokenlabels have been set ***/
char transpose;					/*** indicate transpose mode in DATA block ***/
char dimensionsset;				/*** indicate dimensionsset ***/
char inblock;					/*** indicate block ***/
short hitnodes;					/*** number of nodes for which hold limit hit ***/



// TODO: reference additional headers your program requires here
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the DIVADLL_EXPORTS
// symbol defined on the command line. This symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// DIVADLL_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef DIVADLL_EXPORTS
#define DIVADLL_API __declspec(dllexport)
#else
#define DIVADLL_API __declspec(dllimport)
#endif

// This class is exported from the DIVADLL.dll
class DIVADLL_API CDIVADLL {
public:
	CDIVADLL(void);
	// TODO: add your methods here.
};

extern "C" DIVADLL_API int fnDIVADLL(char a[]);
extern "C" DIVADLL_API int nDIVADLL;
extern "C" DIVADLL_API int divapro(char vbtreeline[], int *genno);